unit UHeadCache;
(* URLɊւ|bvAbṽLbV *)
(* Copyright (c) 2001,2002 Twiddle <hetareprog@hotmail.com> *)

interface

uses
  Classes, StrUtils, Controls,
  jconvert,
  UAsync, UDat2HTML;

type
  (*-------------------------------------------------------*)
  TUrlHeadCache = class(TStringList)
  private
    procedure OnHead(sender: TAsyncReq);
  public
    function GetContents(const URI: string): string;
    function GetCache(const URI: string): string;
  end;




(*=======================================================*)
implementation
(*=======================================================*)

uses
  Main;

const
  MAX_URL_HINT_ENTRY: integer = 256;

(*=======================================================*)
function TUrlHeadCache.GetContents(const URI: string):string;
var
  i: integer;
  s: string;
  reqType: TAsyncReqRequestType;
begin
  result := '';
  s := '$' + URI;
  if MAX_URL_HINT_ENTRY <= Count then
  begin
    Move(Count -1, 0);
    Strings[0] := s;
  end
  else
    Insert(0, s);

{  case Config.hintForURLUseHead of
  true: reqType := agrtHead;
  else reqType := agrtGet;
  end;
}
  //
  if not Config.hintForURLUseHead then
  begin
    reqType := agrtGet;
    if Config.hintCancelGetExt.CommaText <> '' then
    begin
      for i := 0 to Config.hintCancelGetExt.Count -1 do
        if AnsiEndsText(Config.hintCancelGetExt[i], URI) then
        begin
          reqType := agrtHead;
          break;
        end;
    end;
  end else
    reqType := agrtHead;

  LogBeginQuery2;
  if AsyncManager.Get(URI, OnHead, nil, '', 0, Config.hintForURLMaxSize,
                      reqType) = nil then
  begin
    Delete(0);
  end;
  result := '';
end;

function ConvertToShiftJIS(const str: string): string;
begin
  result := ConvertJCode(str, SJIS_OUT);
end;

procedure TUrlHeadCache.OnHead(sender: TAsyncReq);
var
  i: integer;
  s: string;
  server: string;
  cookie: string;
  tmp: string;
begin
  LogEndQuery;
  MainWnd.WriteStatus('');
  s := '$' + sender.URI;
  i := IndexOf(s);
  if 0 <= i then
  begin
    Move(i, 0);
    server := sender.IdHTTP.Response.RawHeaders.Values['Server'];
    cookie := sender.IdHTTP.Response.RawHeaders.Values['Set-Cookie'];
    tmp := '';
    if 0 < length(server) then
      tmp := tmp + 'Server: ' + server + #13#10;
    if 0 < length(cookie) then
      tmp := tmp + 'Set-Cookie: ' + cookie + #13#10;
    Strings[0] := sender.URI + #13#10
                + sender.IdHTTP.ResponseText + #13#10
                + tmp
                + StripBlankLinesForHint(HTML2String(ConvertToShiftJIS(sender.Content)),
                                         Config.hintForURLMaxLine);
    if MainWnd.Active and MouseInPane(MainWnd.WebPanel) then
      MainWnd.ShowHint(Strings[0], Config.hintForURLWidth, Config.hintForURLHeight);
  end;
end;

function TUrlHeadCache.GetCache(const URI: string): string;
var
  i: integer;
  s: string;
begin
  if AnsiContainsText(URI, '.2ch.net/') then
  begin
    result := URI + #13#10 + '2˂̂ǂƎv';
    exit;
  end;
  if AnsiContainsText(URI, '.bbspink.com/') then
  begin
    result := URI + #13#10 + 'l̎Ԃ݂ł';
    exit;
  end;
  s := URI + #13#10;
  for i := 0 to Count -1 do
  begin
    if AnsiStartsText(s, Strings[i]) then
    begin
      result := Strings[i];
      Move(i, 0);
      exit;
    end;
  end;
  result := '';
end;

end.
