// A[JCoR|[lg for Delphi/C++Builder
// Common Archivers Component for Delphi/C++Builder
// Copyright(C) NORG1964/M.Yoneda 1997,1998,1999,2000,2001
//
// BGA32֘AW[	BGA32.PAS
//
// v1.36:UNBEL32.DLLɂBEL`ւ̑ΉJn
// v1.38:DLL ̃Gg|Cg̎擾@ύX
// v1.42:[hDLLԈĂ̂C
//
unit BEL32;

interface

uses
	Windows,
	SysUtils,
	Classes,
	Archives;

type
	TBel32 = class( TArchiver )
	protected
		class procedure LoadDll; override;
		class procedure FreeDll; override;

	private
		FArchiveFileName:	string;

	protected
		function  BuildCmdLine( Cmd,ArchiveFileName:string;Options:TArchiverOptions;Path:String;FileList:array of const;UseResFile:boolean ):String;

		function  FindOpen ( Handle:HWND;ArchiveFileName:string;dwMode:DWORD ):THARC; override;
		function  FindFirst( hArc:THArc;var IndivisualInfo:TIndivisualInfo;FileMask:string ):integer; override;
		function  FindNext ( hArc:THArc;var IndivisualInfo:TIndivisualInfo				   ):integer; override;
		function  FindClose( hArc:THArc													   ):integer; override;

	public
		function Unbel( Handle:HWND;cmdline:string;var Output:string ):Integer;
		function UnpackFiles  ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;DstPath:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer; override;
//		function PackFiles    ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer; override;
//		function RemoveItems  ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer; override;
//		function UpdateArchive( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer; override;
//		function MakeSfx      ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;DstPath:String                                           ;var Output:string ):Integer; override;
//		function UnpackToMem  ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;FileName:string;lpvBuffer:LPVOID;dwSize:DWORD;lpdwWriteSize:LPDWORD   ):Integer; override;
		function CheckArchive (             ArchiveFileName:string;CheckMode:integer;CheckOptions:integer ):DWORD; override;
//		function SetOwnerWindowEx ( Handle:HWND;lpArcProc:LPARCHIVERPROC ):boolean; override;
//		function KillOwnerWindowEx( Handle:HWND							     ):boolean; override;
	end;

	function IsBelArchive( ArchiveFileName:string ):boolean;

//	function UnbelOpenArchive( Handle:HWND;ArchiveFileName:PAnsiChar;dwMode:DWORD ):THARC; stdcall;
//	function UnbelCloseArchive( hArc:THARC ):integer; stdcall;
//	function UnbelFindFirst( hArc:THArc;FileMask:PAnsiChar;IndivisualInfo:PIndivisualInfo ):integer; stdcall;
//	function UnbelFindNext( hArc:THArc;IndivisualInfo:PIndivisualInfo ):integer; stdcall;
//	function UnbelSetOwnerWindowEx( Handle:HWND;lpArcProc:LPARCHIVERPROC ):BOOL; stdcall;

implementation

//---------------------------------------------------------------------
var
	FArchiver:		TArchiverDLL;

procedure LoadDll;
begin
	if Assigned( FArchiver ) then exit;
	FArchiver := TArchiverDll.Create( 'Belon `','Unbel32.dll','Unbel' );
end;

procedure FreeDll;
begin
	FArchiver.Free;
	FArchiver := nil;
end;

//---------------------------------------------------------------------
class procedure TBel32.LoadDll;
begin
	Bel32.LoadDll;
end;

class procedure TBel32.FreeDll;
begin
	Bel32.FreeDll;
end;

function TBel32.UnpackFiles( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;DstPath:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer;
begin
	FCmdLine := BuildCmdLine( 'x',ArchiveFileName,Options,DstPath,FileList,ruOnUnpack in Options.ResFileUsage );
	result := Unbel( Handle,FCmdLine,Output );
end;

//	function TBel32.PackFiles( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer;
//	begin
//		FCmdLine := BuildCmdLine( 'u',ArchiveFileName,Options,BaseDir,FileList,ruOnPack in Options.ResFileUsage );
//		result := Unbel( Handle,FCmdLine,Output );
//	end;

//	function TBel32.RemoveItems( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer;
//	begin
//		FCmdLine := BuildCmdLine( 'd',ArchiveFileName,Options,'',FileList,ruOnRemoveItem in Options.ResFileUsage );
//		result := Unbel( Handle,FCmdLine,Output );
//	end;

//	function TBel32.UpdateArchive( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer;
//	begin
//		FCmdLine := BuildCmdLine( 'f',ArchiveFileName,Options,BaseDir,FileList,ruOnUpdate in Options.ResFileUsage );
//		result := Unbel( Handle,FCmdLine,Output );
//	end;

//	function TBel32.MakeSfx( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;DstPath:String;var Output:string ):Integer;
//	begin
//		FCmdLine := BuildCmdLine( 's',ArchiveFileName,Options,DstPath,[nil],false );
//		result := Unbel( Handle,FCmdLine,Output );
//	end;

//	function TBel32.UnpackToMem( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;FileName:string;lpvBuffer:LPVOID;dwSize:DWORD;lpdwWriteSize:LPDWORD ):Integer;
//	begin
//		FCmdLine := BuildCmdLine( '',ArchiveFileName,Options,'',[FileName],false );
//		result := FArchiver.ExtractMem( Handle,PChar( FCmdLine ),lpvBuffer,dwSize,nil,nil,lpdwWriteSize );
//	end;

function TBel32.CheckArchive( ArchiveFileName:string;CheckMode:integer;CheckOptions:integer ):DWORD;
begin
	result := FArchiver.CheckArchive( PChar( ArchiveFileName ),CheckMode+CheckOptions );
end;

//	function TBel32.SetOwnerWindowEx ( Handle:HWND;lpArcProc:LPARCHIVERPROC ):boolean;
//	begin
//		inherited SetOwnerWindowEx( Handle,lpArcProc );
//		result := FArchiver.SetOwnerWindowEx( Handle,lpArcProc );
//	end;
//
//	function TBel32.KillOwnerWindowEx( Handle:HWND ):boolean;
//	begin
//		result := UnBelKillOwnerWindowEx( Handle );
//		inherited KillOwnerWindowEx( Handle );
//	end;

function TBel32.Unbel( Handle:HWND;CmdLine:string;var Output:string ):Integer;
begin
	result := FArchiver.ArchiverProc( Handle,PChar( CmdLine ),PAnsiChar( Output ),Length( Output ));
end;

function TBel32.BuildCmdLine( Cmd,ArchiveFileName:string;Options:TArchiverOptions;Path:String;FileList:array of const;UseResFile:boolean ):String;
var
	CmdLine:	TCmdOpt;
begin
	with Options do begin
		CmdLine := TCmdOpt.Create;

//		CmdLine.Add( '-+' );			//	ɃWXg̐ݒ𖳎

//		CmdLine.AddIntOpt( 'a'	,a	 );		//	a[0|1|2]				̍ČB
//		CmdLine.AddIntOpt( 'c'	,c	 );		//	c[0|1]				^CX^vȗ
//		CmdLine.AddIntOpt( 'd'	,d	 );		//	d[0|1]				fBNg̊i[
//		CmdLine.AddIntOpt( 'e'	,e	 );		//	e[0|1]				TCY𔼕ɂĈk
//		CmdLine.AddIntOpt( 'f'	,f	 );		//	f[0|1]				fBXNcʃ`FbN̒~
//		CmdLine.AddIntOpt( 'h'	,h	 );		//	h[0|1|2|3]			wb_̌`w
//		CmdLine.AddIntOpt( 'i'	,i	 );		//	i[0|1|2]				t@CIő啶Ə
//		CmdLine.AddIntOpt( 'l'	,l	 );		//	l[0|1|2]				WJÕt@C̕\@̕ύX
//		CmdLine.AddIntOpt( 'm'	,m	 );		//	m[0|1|2]				 yes Ɖ

//		if not CallBackEnabled
//		then CmdLine.AddIntOpt( 'n' ,n )		//	n[0|1]				WJ󋵃_CAO\̗}~
//		else CmdLine.AddIntOpt( 'n' ,1 );	//	n[0|1]				WJ󋵃_CAO\̗}~

//		CmdLine.AddIntOpt( 'o'	,o	 );		//	o[0|1|2]				`ŏɂ쐬
//		CmdLine.AddIntOpt( 'p'	,p	 );		//	p[0|1|2]				SpXōv
//		CmdLine.AddIntOpt( 'r'	,r	 );		//	r[0|1|2]				ċAI
//		CmdLine.AddIntOpt( 's'	,s	 );		//	s[0|1]				XLbv\̗}
//		CmdLine.AddIntOpt( 't'	,t	 );		//	t[0|1]				ɂ̍XV̎w

//		CmdLine.AddIntOpt( 'u'	,u	  );		//	u[0|1]				t@C̍XViV́j
//		CmdLine.AddPath1 ( 'w'  ,w   );		//	w[0|1|<Dir>]		ƗpfBNg̎w
//		CmdLine.AddIntOpt( 'x'	,x	  );		//	x[0|1]				fBNgLɂ
//		CmdLine.AddIntOpt( 'y'	,y	  );		//	y[0|1]				SĂ̎ yes Ɖ
//		CmdLine.AddIntOpt( 'z'	,z	  );		//	z[0|1|2|<gq>]	kt@C̎w			###gq̓T|[gȂ###
//		CmdLine.AddIntOpt( 'jc' ,jc  );		//	jc[0|1]				jwb_𖳎
//		CmdLine.AddIntOpt( 'jd' ,jd  );		//	jd[<TCY>]		fBXN̋󂫗eʂmF
//		CmdLine.AddIntOpt( 'je' ,je  );		//	je[<TCY>]		Huffman obt@̑傫w
//		CmdLine.AddIntOpt( 'jf' ,jf  );		//	jf[0|1]				[gL̍폜
//		CmdLine.AddIntOpt( 'jh' ,jh  );	 	//	jh[0|1]				WindowsNT/95 p̃}[Nɂɕt
//		CmdLine.AddIntOpt( 'ji' ,ji  );		//	ji[0|1]				Zt@CŊi[
//		CmdLine.AddIntOpt( 'jm' ,jm  );		//	jm[0|1|2|3|4]		k`w
//		CmdLine.AddIntOpt( 'jn' ,jn  );		//	jn[0|1]				VKt@Ĉ
//		CmdLine.AddStrOpt( 'jo' ,jo  );		//	jo[<w>]		YYMMDDHHMMSS ̓tȍ~
//		CmdLine.AddStrOpt( 'job',job );		//	job[<w>]	YYMMDDHHMMSS ̓tȑO
//		CmdLine.AddIntOpt( 'jp' ,jp  );		//	jp[0|1]				io[vOXEo[ŕ\
//		CmdLine.AddIntOpt( 'jr' ,jr  );		//	jr[0|1]				t@C̒u
//		CmdLine.AddIntOpt( 'jss',jss );		//	jss[0|1]				kt@CI[vG[𖳎BʏCkɈkΏۃt@
//		CmdLine.AddIntOpt( 'jw' ,jw  );		//	jw[0|1|2|3|4]		WinSFX/WinSFXM 쐬
//		CmdLine.AddFList2( 'jx' ,[jx] );		//	jx[<t@C>]	Ot@C
//		CmdLine.AddIntOpt( 'jyc',jyc );		//	jyc[0|1]				fBNg쐬̊mFȗ
//		CmdLine.AddIntOpt( 'jyd',jyd );		//	jyd[0|1]				t@C폜̊mFȗ
//		CmdLine.AddIntOpt( 'jyk',jyk );		//	jyk[0|1]				gpłfBXNeʂ̊mF̏ȗ
//		CmdLine.AddIntOpt( 'jyn',jyn );		//	jyn[0|1]				Vt@C̗v̏ȗ
//		CmdLine.AddIntOpt( 'jyo',jyo );		//	jyo[0|1]				t@Cւ̏㏑mF̏ȗ
//		CmdLine.AddStrOpt( 'jz' ,jz  );		//	jz[<t@C>]	t@C߂̃t@C
//		CmdLine.AddIntOpt( 'ga' ,ga  );		//	ga[0|1]				ݕs𖳎
//		CmdLine.AddIntOpt( 'gd' ,gd  );		//	gd[0|1]				]ȃf[^̍폜
//		CmdLine.AddIntOpt( 'ge' ,ge  );		//	ge[0|1]				ŏ̊gqF
//		CmdLine.AddIntOpt( 'gf' ,gf  );		//	gf[0|1|2]			łɂt@C̍XV
//		CmdLine.AddIntOpt( 'gj' ,gj  );		//	gj[0|1]				x ߂ e ߂ƓlƌȂ
//		CmdLine.AddIntOpt( 'gm' ,gm  );		//	gm[0|1]				G[bZ[W\̗}~
//		CmdLine.AddIntOpt( 'gn' ,gn  );		//	gn[0|1|2]			WJt@C̍vTCY 100% ƂiOt̕\
//		CmdLine.AddIntOpt( 'go' ,go  );		//	go[0|1]				_CAÕI[i[EBhE̎w
//		CmdLine.AddIntOpt( 'gp' ,gp  );		//	gp[0|1]				EBhE Disable ɂȂ
//		CmdLine.AddStrOpt( 'gr' ,gr  );		//	gr[<t@C>]	ύXt@C
//		CmdLine.AddIntOpt( 'gs' ,gs  );		//	gs[<TCY>]		wb_TCY̎w
//		CmdLine.AddIntOpt( 'gu' ,gu  );		//	gu[0|1]				WinSFXCDosSFX ɑSẴt@Ci[
//		CmdLine.AddIntOpt( 'gw' ,gw  );		//	gw[0|1|2|3|4]		WinSFX32/WinSFX32M 쐬

		CmdLine.Add( UserOptions );

		AddFileSpec1( CmdLine,ArchiveFileName,Path );
//		AddFileSpec2( CmdLine,Options,FileList,UseResFile );

		result := cmd + CmdLine.Str;	//	v0.43ȏ̎
//		result := ArchiveFileName;		//	v0.43̎-T|[gȂ

		CmdLine.Free;
	end;
end;

function TBel32.FindOpen( Handle:HWND;ArchiveFileName:string;dwMode:DWORD ):THARC;
begin
	FArchiveFileName := ExpandFileName( ArchiveFileName );
	result:= 1;	//	0 łȂ΂Ȃł悢
end;

function TBel32.FindClose( hArc:THArc ):integer;
begin
	FArchiveFileName := '';
	result := 0;
end;

function TBel32.FindFirst( hArc:THArc;var IndivisualInfo:TIndivisualInfo;FileMask:string ):integer;
begin
//	result := FArchiver.FindFirst( hArc,PChar( FileMask ),@IndivisualInfo );
	result := FArchiver.FindFirst( hArc,PChar( FArchiveFileName ),@IndivisualInfo );
	result := 0;
end;

function TBel32.FindNext( hArc:THArc;var IndivisualInfo:TIndivisualInfo ):integer;
begin
	result := FArchiver.FindNext( hArc,@IndivisualInfo )
end;

function IsBelArchive( ArchiveFileName:string ):boolean;
begin
	try
		LoadDLL;
		ArchiveFileName := ExpandFileName( ArchiveFileName );
		result := FArchiver.CheckArchive( PChar( ArchiveFileName ),0 ) <> 0;	//	܂ĂɂȂȂ̂ŒӁI
	except
		result := false;
	end;
end;

end.
