// A[JCoR|[lg for Delphi/C++Builder
// Common Archivers Component for Delphi/C++Builder
// Copyright(C) NORG1964/M.Yoneda 1997-2002
//
// RAR32֘AW[	RAR32.PAS
//
// v1.12:Jo[W
// v1.17:LoadDll/FreeDll/IsXXXArchive ̍\ύX
// v1.21:LoadDll/FreeDll ̉xύX
// v1.22:o߃CxgT|[gǉ
// v1.23:CheckArchive \bhǉ
//       ȃ\bh̉
// v1.25:ZIP32J.DLLł̖O"["܂ރt@Cւ̑Ή
// v1.28:WJ@\̃T|[gǉ
//	      CheckArchive \bh̖߂ľ^ύX
// v1.30:e\bh FileList ̌^ύX
// v1.32:IsSetOwnerWinow/KillOwnerWindow ̎ύX
// v1.35:TRar32.Rar  CmdLine ĂȂs̏C
// v1.38:DLL ̃Gg|Cg̎擾@ύX
// v1.40: DLL [hĂs̏C ( 1.38 ŃGoO )
// v1.48:gy nIvṼRgǉ
//
unit RAR32;

interface

uses Windows,SysUtils,Classes,Archives;

type
	TRar32 = class( TArchiver )
	protected
		class procedure LoadDll; override;
		class procedure FreeDll; override;

	protected
		function  BuildCmdLine( Cmd,ArchiveFileName:string;Options:TArchiverOptions;Path:String;FileList:array of const;UseResFile:boolean ):String;

		function  FindOpen ( Handle:HWND;ArchiveFileName:string;dwMode:DWORD ):THARC; override;
		function  FindFirst( hArc:THArc;var IndivisualInfo:TIndivisualInfo;FileMask:string ):integer; override;
		function  FindNext ( hArc:THArc;var IndivisualInfo:TIndivisualInfo				   ):integer; override;
		function  FindClose( hArc:THArc													   ):integer; override;

	public
		function Rar( Handle:HWND;CmdLine:string;var Output:string ):Integer;

		function UnpackFiles  ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;DstPath:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer; override;
//		function PackFiles    ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer; override;
//		function RemoveItem   ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer; override;
//		function MakeSfxFile  ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions                                                          ;var Output:string ):Integer; override;
		function UnpackToMem  ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;FileName:string;lpvBuffer:LPVOID;dwSize:DWORD;lpdwWriteSize:LPDWORD         ):Integer; override;
		function CheckArchive ( ArchiveFileName:string;CheckMode:integer;CheckOptions:integer ):DWORD; override;

		function SetOwnerWindowEx ( Handle:HWND;lpArcProc:LPARCHIVERPROC ):boolean; override;
		function KillOwnerWindowEx( Handle:HWND                          ):boolean; override;
	end;

	function IsRarArchive( ArchiveFileName:string ):boolean;

implementation

//---------------------------------------------------------------------
var
	FArchiver:		TArchiverDLL;

procedure LoadDll;
begin
	if Assigned( FArchiver ) then exit;
	FArchiver := TArchiverDll.Create( 'RAR `','UNRAR32.DLL','Unrar' );
	FArchiver.LoadDLL;
end;

procedure FreeDll;
begin
	FArchiver.Free;
	FArchiver := nil;
end;

//----------------------------------------------------------------------------------------------------------------------
class procedure TRar32.LoadDll;
begin
	Rar32.LoadDll;
end;

class procedure TRar32.FreeDll;
begin
	Rar32.FreeDll;
end;

function TRar32.UnpackFiles( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;DstPath:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer;
var
	Cmd:	string;
begin
	if Options.x = 0
	then Cmd := '-e'
	else Cmd := '-x';
	FCmdLine := BuildCmdLine( Cmd,ArchiveFileName,Options,DstPath,FileList,ruOnUnpack in Options.ResFileUsage );
	result := Rar( Handle,FCmdLine,Output );
end;
{
function TRar32.PackFiles( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer;
begin
	FCmdLine := BuildCmdLine( '-x',ArchiveFileName,Options,BaseDir,FileList,ruOnPack in Options.ResFileUsage );
	result := Rar( Handle,FCmdLine,Output );
end;

function TRar32.RemoveItem( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer;
begin
	FCmdLine := BuildCmdLine( '',ArchiveFileName,Options,'',FileList );
	result := Rar( Handle,FCmdLine,Output );
end;

function TRar32.MakeSfxFile( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;var Output:string ):Integer;
begin
	FCmdLine := BuildCmdLine( '',ArchiveFileName,Options,'',nil );
	result := Rar( Handle,FCmdLine,Output );
end;
}
function TRar32.UnpackToMem( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;FileName:string;lpvBuffer:LPVOID;dwSize:DWORD;lpdwWriteSize:LPDWORD ):Integer;
begin
	FCmdLine := BuildCmdLine( '',ArchiveFileName,Options,'',[FileName],false );
	result:= FArchiver.ExtractMem( Handle,PChar( FCmdLine ),lpvBuffer,dwSize,nil,nil,lpdwWriteSize );
end;

function TRar32.CheckArchive( ArchiveFileName:string;CheckMode:integer;CheckOptions:integer ):DWORD;
begin
	result := FArchiver.CheckArchive( PChar( ArchiveFileName ),CheckMode+CheckOptions );
end;

function TRar32.SetOwnerWindowEx ( Handle:HWND;lpArcProc:LPARCHIVERPROC ):boolean;
begin
	inherited SetOwnerWindowEx( Handle,lpArcProc );
	result := FArchiver.SetOwnerWindowEx( Handle,lpArcProc );
end;

function TRar32.KillOwnerWindowEx( Handle:HWND ):boolean;
begin
	result := FArchiver.KillOwnerWindowEx( Handle );
	inherited KillOwnerWindowEx( Handle );
end;

function TRar32.Rar( Handle:HWND;CmdLine:string;var Output:string ):Integer;
begin
	result := FArchiver.ArchiverProc( Handle,PChar( CmdLine ),PAnsiChar( Output ),Length( Output ));
end;

function TRar32.BuildCmdLine( Cmd,ArchiveFileName:string;Options:TArchiverOptions;Path:String;FileList:array of const;UseResFile:boolean ):String;
var
	CmdLine:	TCmdOpt;
begin
	with Options do begin
		CmdLine := TCmdOpt.Create;
//		CmdLine.Add( '-+' );			//	ɃWXg̐ݒ𖳎

//		CmdLine.AddIntOpt( 'a'	,a	 );		//	a[0|1|2]				̍ČB
		if c < 1 then CmdLine.Add( '-u' );	//	c[0|1]				^CX^vȗ
//		CmdLine.AddIntOpt( 'd'	,d	 );		//	d[0|1]				fBNg̊i[
//		CmdLine.AddIntOpt( 'e'	,e	 );		//	e[0|1]				TCY𔼕ɂĈk
//		CmdLine.AddIntOpt( 'f'	,f	 );		//	f[0|1]				fBXNcʃ`FbN̒~
//		CmdLine.AddIntOpt( 'h'	,h	 );		//	h[0|1|2|3]			wb_̌`w
//		CmdLine.AddIntOpt( 'i'	,i	 );		//	i[0|1|2]				t@CIő啶Ə
//		CmdLine.AddIntOpt( 'l'	,l	 );		//	l[0|1|2]				WJÕt@C̕\@̕ύX
		if m > 0 then CmdLine.Add( '-y' );	//	m[0|1|2]				 yes Ɖ
//		CmdLine.AddIntOpt( 'n'	,n	 );		//	n[0|1]				WJ󋵃_CAO\̗}~
//		CmdLine.AddIntOpt( 'o'	,o	 );		//	o[0|1|2]				`ŏɂ쐬
		if p > 0 then CmdLine.Add( '-s' );	//	p[0|1|2]				SpXōv
//		CmdLine.AddIntOpt( 'r'	,r	 );		//	r[0|1|2]				ċAI
//		CmdLine.AddIntOpt( 's'	,s	 );		//	s[0|1]				XLbv\̗}
//		CmdLine.AddIntOpt( 't'	,t	 );		//	t[0|1]				ɂ̍XV̎w
//		CmdLine.AddIntOpt( 'u'	,u	 );		//	u[0|1]				t@C̍XViV́j
//		CmdLine.AddPathName( 'w'  ,w   );	//	w[0|1|<Dir>]		ƗpfBNg̎w
//		CmdLine.AddIntOpt( 'x'	,x	 );		//	x[0|1]				fBNgLɂ
//		CmdLine.AddIntOpt( 'y'	,y	 );		//	y[0|1]				SĂ̎ yes Ɖ
//		CmdLine.AddIntOpt( 'z'	,z	 );		//	z[0|1|2|<gq>]	kt@C̎w			###gq̓T|[gȂ###
//		CmdLine.AddIntOpt( 'jc' ,jc	 );		//	jc[0|1]				jwb_𖳎
//		CmdLine.AddIntOpt( 'jd' ,jd	 );		//	jd[<TCY>]		fBXN̋󂫗eʂmF
//		CmdLine.AddIntOpt( 'je' ,je	 );		//	je[<TCY>]		Huffman obt@̑傫w
//		CmdLine.AddIntOpt( 'jf' ,jf	 );		//	jf[0|1]				[gL̍폜
//		CmdLine.AddIntOpt( 'jh' ,jh	 );		//	jh[0|1]				WindowsNT/95 p̃}[Nɂɕt
//		CmdLine.AddIntOpt( 'ji' ,ji	 );		//	ji[0|1]				Zt@CŊi[
//		CmdLine.AddIntOpt( 'jm' ,jm	 );		//	jm[0|1|2|3|4]		k`w
//		CmdLine.AddIntOpt( 'jn' ,jn	 );		//	jn[0|1]				VKt@Ĉ
//		CmdLine.AddStrOpt( 'jo' ,jo	 );		//	jo[<w>]		YYMMDDHHMMSS ̓tȍ~
//		CmdLine.AddStrOpt( 'job',job );		//	job[<w>]	YYMMDDHHMMSS ̓tȑO
//		CmdLine.AddIntOpt( 'jp' ,jp	 );		//	jp[0|1]				io[vOXEo[ŕ\
//		CmdLine.AddIntOpt( 'jr' ,jr	 );		//	jr[0|1]				t@C̒u
//		CmdLine.AddIntOpt( 'jss',jss );		//	jss[0|1]				kt@CI[vG[𖳎BʏCkɈkΏۃt@
//		CmdLine.AddIntOpt( 'jw' ,jw	 );		//	jw[0|1|2|3|4]		WinSFX/WinSFXM 쐬
//		CmdLine.AddLstOpt( 'jx' ,jx	 );		//	jx[<t@C>]	Ot@C
//		CmdLine.AddIntOpt( 'jyc',jyc );		//	jyc[0|1]				fBNg쐬̊mFȗ
//		CmdLine.AddIntOpt( 'jyd',jyd );		//	jyd[0|1]				t@C폜̊mFȗ
//		CmdLine.AddIntOpt( 'jyk',jyk );		//	jyk[0|1]				gpłfBXNeʂ̊mF̏ȗ
//		CmdLine.AddIntOpt( 'jyn',jyn );		//	jyn[0|1]				Vt@C̗v̏ȗ
//		CmdLine.AddIntOpt( 'jyo',jyo );		//	jyo[0|1]				t@Cւ̏㏑mF̏ȗ
//		CmdLine.AddStrOpt( 'jz' ,jz  );		//	jz[<t@C>]	t@C߂̃t@C
//		CmdLine.AddIntOpt( 'ga' ,ga  );		//	ga[0|1]				ݕs𖳎
//		CmdLine.AddIntOpt( 'gd' ,gd  );		//	gd[0|1]				]ȃf[^̍폜
//		CmdLine.AddIntOpt( 'ge' ,ge  );		//	ge[0|1]				ŏ̊gqF
//		CmdLine.AddIntOpt( 'gf' ,gf  );		//	gf[0|1|2]			łɂt@C̍XV
//		CmdLine.AddIntOpt( 'gj' ,gj  );		//	gj[0|1]				x ߂ e ߂ƓlƌȂ
//		CmdLine.AddIntOpt( 'gm' ,gm  );		//	gm[0|1]				G[bZ[W\̗}~
//		CmdLine.AddIntOpt( 'gn' ,gn  );		//	gn[0|1|2]			WJt@C̍vTCY 100% ƂiOt̕\
//		CmdLine.AddIntOpt( 'go' ,go  );		//	go[0|1]				_CAÕI[i[EBhE̎w
//		CmdLine.AddIntOpt( 'gp' ,gp  );		//	gp[0|1]				EBhE Disable ɂȂ
//		CmdLine.AddIntOpt( 'gr' ,gr  );		//	gr[<t@C>]	ύXt@C
//		CmdLine.AddIntOpt( 'gs' ,gs  );		//	gs[<TCY>]		wb_TCY̎w
//		CmdLine.AddIntOpt( 'gu' ,gu  );		//	gu[0|1]				WinSFXCDosSFX ɑSẴt@Ci[
//		CmdLine.AddIntOpt( 'gw' ,gw  );		//	gw[0|1|2|3|4]		WinSFX32/WinSFX32M 쐬
//		CmdLine.AddIntOpt( 'gya',gya );		//	gya[0|1]				  [-gya1]
//		CmdLine.AddIntOpt( 'gyc',gyc );		//	gyc[0|1]				^CX^v`FbN̏ȗ  [-gyc1]
//		CmdLine.AddStrOpt( 'gyd',gyd );		//	gyd<fBNg>	𓀐fBNgw
//		CmdLine.AddStrOpt( 'gye',gye );		//	gye<R}h>		sR}hw
//		CmdLine.AddIntOpt( 'gyo',gyo );		//	gyo[0|1]				㏑w(㏑mFsȂ)  [-gyo0]
//		CmdLine.AddIntOpt( 'gyq',gyq );		//	gyq[0|1]				sw  [-gyq0]
//		CmdLine.AddIntOpt( 'gys',gys );		//	gys[0|1]				₃`FbNs  [-gys0]
//		CmdLine.AddStrOpt( 'gyt',gyt );		//	gyt<^Cg>		𓀐fBNg^Cg̐ݒ
//		CmdLine.AddStrOpt( 'gyw',gyw );		//	gyw<^Cg>		_CAÕ^Cg̐ݒ
//		CmdLine.AddIntOpt( 'gyx',gyx );		//	gyx[0|1]				fBNg̕s  [-gyx0]

		CmdLine.Add( UserOptions );

		AddFileSpec1( CmdLine,ArchiveFileName,Path );
		AddFileSpec2( CmdLine,Options,FileList,UseResFile );

		result := cmd + CmdLine.Str;
		CmdLine.Free;
	end;
end;

function TRar32.FindOpen( Handle:HWND;ArchiveFileName:string;dwMode:DWORD ):THARC;
begin
	result := FArchiver.OpenArchive( Handle,PChar( ExpandFileName( ArchiveFileName )),dwMode );
end;

function TRar32.FindClose( hArc:THArc ):integer;
begin
	result := FArchiver.CloseArchive( hArc );
end;

function TRar32.FindFirst( hArc:THArc;var IndivisualInfo:TIndivisualInfo;FileMask:string ):integer;
begin
	result := FArchiver.FindFirst( hArc,PChar( FileMask ),@IndivisualInfo );
end;

function TRar32.FindNext( hArc:THArc;var IndivisualInfo:TIndivisualInfo ):integer;
begin
	result := FArchiver.FindNext( hArc,@IndivisualInfo )
end;

function IsRarArchive( ArchiveFileName:string ):boolean;
var
	hArc:		THARC;
begin
	try
		LoadDLL;
		hArc := FArchiver.OpenArchive( 0,PAnsiChar( ExpandFileName( ArchiveFileName )),M_REGARDLESS_INIT_FILE+M_ERROR_MESSAGE_OFF );
		FArchiver.CloseArchive( hArc );
		result := ( hArc <> 0 );
	except
		result := false;
	end;
end;

end.
