// A[JCoR|[lg for Delphi/C++Builder
// Common Archivers Component for Delphi/C++Builder
// Copyright(C) NORG1964/M.Yoneda 1997,1998,1999,2000
//
// 7zip ֘AW[ SZIP32.PAS
//
// v1.44:Jo[W
// v1.46:7-zip32.dll ̃R}hCdl̕ύXɑΉ
// v1.48:gy nIvṼRgǉ
//
unit SZIP32;

interface

{$INCLUDE VERSION.INC}

uses
	Windows,
	SysUtils,
	Classes,
	Archives;

type
	TSevenZip32 = class( TArchiver )
	protected
		class procedure LoadDll; override;
		class procedure FreeDll; override;

	protected
		function  BuildCmdLine( Cmd,ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean ):String;

		function  FindOpen ( Handle:HWND;ArchiveFileName:string;dwMode:DWORD ):THARC; override;
		function  FindFirst( hArc:THArc;var IndivisualInfo:TIndivisualInfo;FileMask:string ):integer; override;
		function  FindNext ( hArc:THArc;var IndivisualInfo:TIndivisualInfo				   ):integer; override;
		function  FindClose( hArc:THArc													   ):integer; override;

	public
		function SevenZip( Handle:HWND;cmdline:string;var Output:string ):Integer;
		function UnpackFiles  ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;DstPath:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer; override;
		function PackFiles    ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer; override;
		function RemoveItems  ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer; override;
//		function UpdateArchive( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer; override;
		function MakeSfx      ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;DstPath:String                                           ;var Output:string ):Integer; override;
//		function UnpackToMem  ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;FileName:string;lpvBuffer:LPVOID;dwSize:DWORD;lpdwWriteSize:LPDWORD   ):Integer; override;
		function CheckArchive (             ArchiveFileName:string;CheckMode:integer;CheckOptions:integer ):DWORD; override;
		function SetOwnerWindowEx ( Handle:HWND;lpArcProc:LPARCHIVERPROC ):boolean; override;
		function KillOwnerWindowEx( Handle:HWND							     ):boolean; override;
	end;

	function IsSevenZipArchive( ArchiveFileName:string ):boolean;

{$WRITEABLECONST ON}

const
	SfxModuleNames:		array[0..4] of PChar = (
		'7z.sfx',		//	Windows o[WB
		'7zC.sfx',		//	kꂽ Windows o[WB
		'7zCon.sfx',	//	R\[o[WB
		'7zS.sfx',		//	CXg[ Windows o[WB
		'7zSD.sfx'		//	CXg[ Windows o[WB
	);
	SfxConfigName:		PChar = nil;			//	SFX Installer Config File
	SfxModuleName:		PChar = nil;

implementation

uses
	Registry,
	Filters;

//---------------------------------------------------------------------
var
	FArchiver:		TArchiverDll;

procedure LoadDll;
begin
	if Assigned( FArchiver ) then exit;
	FArchiver := TArchiverDll.Create( '7z `','7-zip32.dll','SevenZip' );
	FArchiver.LoadDLL;
end;

procedure FreeDll;
begin
	FArchiver.Free;
	FArchiver := nil;
end;

//---------------------------------------------------------------------
class procedure TSevenZip32.LoadDll;
begin
	SZIP32.LoadDLL;
end;

class procedure TSevenZip32.FreeDll;
begin
	SZIP32.FreeDll;
end;

function TSevenZip32.UnpackFiles( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;DstPath:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer;
begin
	FCmdLine := BuildCmdLine( 'x',ArchiveFileName,Options,DstPath,FileList,ruOnUnpack in Options.ResFileUsage );
	result := SevenZip( Handle,FCmdLine,Output );
end;

function TSevenZip32.PackFiles( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer;
begin
	FCmdLine := BuildCmdLine( 'u',ArchiveFileName,Options,BaseDir,FileList,ruOnPack in Options.ResFileUsage );
	result := SevenZip( Handle,FCmdLine,Output );
end;

function TSevenZip32.RemoveItems( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer;
begin
	FCmdLine := BuildCmdLine( 'd',ArchiveFileName,Options,'',FileList,ruOnRemoveItem in Options.ResFileUsage );
	result := SevenZip( Handle,FCmdLine,Output );
end;
{
function TSevenZip32.UpdateArchive( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer;
begin
	FCmdLine := BuildCmdLine( 'f',ArchiveFileName,Options,BaseDir,FileList,ruOnUpdate in Options.ResFileUsage );
	result := SevenZip( Handle,FCmdLine,Output,BaseDir );
end;
}

function GetRegistryString( KeyName:string;EntryName:string ):string;
var
	Registry:	TRegistry;
begin
{$IFDEF D4_OR_EARLIER}
	Registry := TRegistry.Create;
{$ELSE}
	Registry := TRegistry.Create( KEY_READ );
{$ENDIF}
	try
		Registry.RootKey := HKEY_LOCAL_MACHINE;
		if Registry.OpenKey( KeyName,False )
		then begin
			Result := Registry.ReadString( EntryName );
		end else begin
			Result := '';
		end;
	finally
		Registry.Free;
	end;
end;

function TSevenZip32.MakeSfx( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;DstPath:String;var Output:string ):Integer;
var
	SfxFileName:	array[0..511] of char;
	SfxHead:			TFileStream;
	CfgFile:			TFileStream;
	SfxFile:			TFileStream;
	ArcFile:			TFileStream;
	P:					PAnsiChar;
	SevenZipPath:	string;
	SfxName:			string;
begin
	SevenZipPath := GetRegistryString( 'SOFTWARE\7-ZIP','Path' );

	if SfxModuleName = nil then SfxModuleName := SfxModuleNames[0];

	if Options.gw > 0
	then begin
		if SearchPath( PChar( SevenZipPath ),SfxModuleName,nil,SizeOf( SfxFileName ),SfxFileName,P ) = 0
		then begin
			if SearchPath( nil,SfxModuleName,nil,SizeOf( SfxFileName ),SfxFileName,P ) = 0
			then begin
				raise ESfxNoRequiredFile.Create( '7z','',SfxModuleName );
			end;
		end;
	end else begin
		raise EArchiver.Create( '16bit SFX 쐬邱Ƃ͂ł܂B' );
	end;

	SfxName := ChangeFileExt( ArchiveFileName,'.exe' );
	if DstPath <> ''
	then begin
		SfxName := ExtractFileName( SfxName );
		SfxName := MakeFileName( DstPath,SfxName );
	end;
	SfxFile := TFileStream.Create( SfxName        ,fmCreate                    );
	SfxHead := TFileStream.Create( SfxFileName    ,fmOpenRead+fmShareDenyWrite );
	if SfxConfigName <> nil
	then begin
		CfgFile := TFileStream.Create( SfxConfigName  ,fmOpenRead+fmShareDenyWrite );
	end else begin
		CfgFile := nil;
	end;
	ArcFile := TFileStream.Create( ArchiveFileName,fmOpenRead+fmShareDenyWrite );
	if SfxConfigName <> nil
	then begin
		CfgFile := TFileStream.Create( SfxConfigName  ,fmOpenRead+fmShareDenyWrite );
	end;
	try
		SfxFile.CopyFrom( SfxHead,0 );
		if Assigned( CfgFile ) then CfgFile.CopyFrom( CfgFile,0 );
		SfxFile.CopyFrom( ArcFile,0 );
	finally
		ArcFile.Free;
		CfgFile.Free;
		SfxHead.Free;
		SfxFile.Free;
	end;

	result := 0;
end;
{
function TSevenZip32.UnpackToMem( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;FileName:string;lpvBuffer:LPVOID;dwSize:DWORD;lpdwWriteSize:LPDWORD ):Integer;
begin
	FCmdLine := BuildCmdLine( '',ArchiveFileName,Options,'',[FileName],false );
	result := FArchiver.ExtractMem( Handle,PChar( FCmdLine ),lpvBuffer,dwSize,nil,nil,lpdwWriteSize );
end;
}
function TSevenZip32.CheckArchive( ArchiveFileName:string;CheckMode:integer;CheckOptions:integer ):DWORD;
begin
	result := FArchiver.CheckArchive( PChar( ArchiveFileName ),CheckMode+CheckOptions );
end;

function TSevenZip32.SetOwnerWindowEx ( Handle:HWND;lpArcProc:LPARCHIVERPROC ):boolean;
begin
	inherited SetOwnerWindowEx( Handle,lpArcProc );
	result := FArchiver.SetOwnerWindowEx( Handle,lpArcProc );
end;

function TSevenZip32.KillOwnerWindowEx( Handle:HWND ):boolean;
begin
	result := FArchiver.KillOwnerWindowEx( Handle );
	inherited KillOwnerWindowEx( Handle );
end;

function TSevenZip32.SevenZip( Handle:HWND;CmdLine:string;var Output:string ):Integer;
begin
	result := FArchiver.ArchiverProc( Handle,PChar( CmdLine ),PAnsiChar( Output ),Length( Output ));
end;

function TSevenZip32.BuildCmdLine( Cmd,ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean ):String;
var
	CmdLine:		TCmdOpt;
begin
// T|[gIvV
// -hide : 󋵃_CAO\̗}~
// -r    : TufBNg̍ċAI
// -o    : o͐fBNg̐ݒ
// -w    : ƃfBNg̐ݒ
// -y    : SĂ̎ yes 
// -x    : t@CO
// -ao   : 𓀎㏑[h

// ʂ̕@ŎIvV
// -u    : XVIvV
// -sfx  : ȉ𓀏ɂ̍쐬

//	ʃT|[gȂIvV
// -p    : pX[h̐ݒ
// -i    : ǉt@Cw
// -m    : k̐ݒ
// -t    : ɂ̌`ݒ

	with Options do begin
		CmdLine := TCmdOpt.Create;
//		CmdLine.Format := cfOuter;

		try
//			CmdLine.Add( '-+' );			//	ɃWXg̐ݒ𖳎

			//	㏑wIvV
			if cmd = 'x'
			then begin
				if m = 2
				then begin
					CmdLine.Add( '-aou' );	//	Oςĉ
				end else begin
					if jn > 0
					then begin
						CmdLine.Add( '-aos' );	//	㏑Ȃ
					end else begin
						if c > 0
						then begin
							CmdLine.Add( '-aoa' );	// ^CX^vrɏ㏑AƂӖ
						end else begin
							//	^CX^vrĐVΉ𓀁|Yw肪Ȃ
						end;
					end;
				end;
			end;

			CmdLine.Add( '-ms=off' );	//	7z `̎͏Ɏw肷

//			CmdLine.AddIntOpt( 'a'	,a	 );		//	a[0|1|2]				̍ČB
//			CmdLine.AddIntOpt( 'c'	,c	 );		//	c[0|1]				^CX^vȗ
//	//		CmdLine.AddIntOpt( 'd'	,d	 );		//	d[0|1]				fBNg̊i[
//			CmdLine.AddIntOpt( 'e'	,e	 );		//	e[0|1]				TCY𔼕ɂĈk
//			CmdLine.AddIntOpt( 'f'	,f	 );		//	f[0|1]				fBXNcʃ`FbN̒~
//			CmdLine.AddIntOpt( 'h'	,h	 );		//	h[0|1|2|3]			wb_̌`w
//			CmdLine.AddIntOpt( 'i'	,i	 );		//	i[0|1|2]				t@CIő啶Ə
//			CmdLine.AddIntOpt( 'l'	,l	 );		//	l[0|1|2]				WJÕt@C̕\@̕ύX
//			CmdLine.AddIntOpt( 'm'	,m	 );		//	m[0|1|2]				 yes Ɖ

			if n > 0      								//	n[0|1]				WJ󋵃_CAO\̗}~
			then CmdLine.Add( '-hide' );

//			CmdLine.AddIntOpt( 'o'	,o	 );		//	o[0|1|2]				`ŏɂ쐬
//			CmdLine.AddIntOpt( 'p'	,p	 );		//	p[0|1|2]				SpXōv

			if r = 0 then CmdLine.Add( '-r-' );	//	r[0|1|2]				ċAI
			if r > 1 then CmdLine.Add( '-r'  );

//			CmdLine.AddIntOpt( 's'	,s	 );		//	s[0|1]				XLbv\̗}
//			CmdLine.AddIntOpt( 't'	,t	 );		//	t[0|1]				ɂ̍XV̎w
//
//			CmdLine.AddIntOpt( 'u'	,u	  );		//	u[0|1]				t@C̍XViV́j
			CmdLine.AddPath1 ( 'w'  ,w   );		//	w[0|1|<Dir>]		ƗpfBNg̎w
//			CmdLine.AddIntOpt( 'x'	,x	  );		//	x[0|1]				fBNgLɂ

			if y > 0										//	y[0|1]				SĂ̎ yes Ɖ
			then CmdLine.Add( '-y' );

//			CmdLine.AddIntOpt( 'z'	,z	  );		//	z[0|1|2|<gq>]	kt@C̎w			###gq̓T|[gȂ###
//			CmdLine.AddIntOpt( 'jc' ,jc  );		//	jc[0|1]				jwb_𖳎
//			CmdLine.AddIntOpt( 'jd' ,jd  );		//	jd[<TCY>]		fBXN̋󂫗eʂmF
//			CmdLine.AddIntOpt( 'je' ,je  );		//	je[<TCY>]		Huffman obt@̑傫w
//			CmdLine.AddIntOpt( 'jf' ,jf  );		//	jf[0|1]				[gL̍폜
//			CmdLine.AddIntOpt( 'jh' ,jh  );	 	//	jh[0|1]				WindowsNT/95 p̃}[Nɂɕt
//			CmdLine.AddIntOpt( 'ji' ,ji  );		//	ji[0|1]				Zt@CŊi[
//			CmdLine.AddIntOpt( 'jm' ,jm  );		//	jm[0|1|2|3|4]		k`w
//			CmdLine.AddIntOpt( 'jn' ,jn  );		//	jn[0|1]				VKt@Ĉ
//			CmdLine.AddStrOpt( 'jo' ,jo  );		//	jo[<w>]		YYMMDDHHMMSS ̓tȍ~
//			CmdLine.AddStrOpt( 'job',job );		//	job[<w>]	YYMMDDHHMMSS ̓tȑO
//			CmdLine.AddIntOpt( 'jp' ,jp  );		//	jp[0|1]				io[vOXEo[ŕ\
//			CmdLine.AddIntOpt( 'jr' ,jr  );		//	jr[0|1]				t@C̒u
//			CmdLine.AddIntOpt( 'jsb',jsb );		//	jsb[0|1]				bZ[W[v񂳂Ȃ
//			CmdLine.AddIntOpt( 'jsc',jsc );		//	jsc[0|1]				WJłȂt@CԂ
//			CmdLine.AddIntOpt( 'jsd',jsd );		//	jsd[0|1]				󂫗eʎ擾Ɏsꍇ̏w
//			CmdLine.AddIntOpt( 'jse',jse );		//	jse[0|1]				WJ̏㏑I[vG[Ƃ
//			CmdLine.AddIntOpt( 'jsf',jsf );		//	jsf[0|1]				^CX^v̕␳sȂ
//			CmdLine.AddIntOpt( 'jsl',jsl );		//	jsl[0|1]				kEi[t@C̏d`FbNsȂ
//			CmdLine.AddIntOpt( 'jso',jso );		//	jso[0|1]				SH_DENYNO ł̃I[vsȂ
//			CmdLine.AddIntOpt( 'jss',jss );		//	jss[0|1]				LG[̏ꍇɏ𑱍s
//			CmdLine.AddIntOpt( 'jst',jst );		//	jst[0|1]				FILETIME \̃wb_̊i[ȗ
//			CmdLine.AddIntOpt( 'jsv',jsv );		//	jsv[0|1]				ɑɏɂ`FbN
//			CmdLine.AddIntOpt( 'jsz',jsz );		//	jsz[0|1]				̊gqt
//			CmdLine.AddIntOpt( 'jw' ,jw  );		//	jw[0|1|2|3|4]		WinSFX/WinSFXM 쐬

			CmdLine.AddFList2( 'x!' ,[jx] );		//	jx[<t@C>]	Ot@C

//			CmdLine.AddIntOpt( 'jyc',jyc );		//	jyc[0|1]				fBNg쐬̊mFȗ
//			CmdLine.AddIntOpt( 'jyd',jyd );		//	jyd[0|1]				t@C폜̊mFȗ
//			CmdLine.AddIntOpt( 'jyk',jyk );		//	jyk[0|1]				gpłfBXNeʂ̊mF̏ȗ
//			CmdLine.AddIntOpt( 'jyn',jyn );		//	jyn[0|1]				Vt@C̗v̏ȗ
//			CmdLine.AddIntOpt( 'jyo',jyo );		//	jyo[0|1]				t@Cւ̏㏑mF̏ȗ
//			CmdLine.AddStrOpt( 'jz' ,jz  );		//	jz[<t@C>]	t@C߂̃t@C
//			CmdLine.AddIntOpt( 'ga' ,ga  );		//	ga[0|1]				ݕs𖳎
//			CmdLine.AddIntOpt( 'gd' ,gd  );		//	gd[0|1]				]ȃf[^̍폜
//			CmdLine.AddIntOpt( 'ge' ,ge  );		//	ge[0|1]				ŏ̊gqF
//			CmdLine.AddIntOpt( 'gf' ,gf  );		//	gf[0|1|2]			łɂt@C̍XV
//			CmdLine.AddIntOpt( 'gj' ,gj  );		//	gj[0|1]				x ߂ e ߂ƓlƌȂ
//			CmdLine.AddIntOpt( 'gm' ,gm  );		//	gm[0|1]				G[bZ[W\̗}~
//			CmdLine.AddIntOpt( 'gn' ,gn  );		//	gn[0|1|2]			WJt@C̍vTCY 100% ƂiOt̕\
//			CmdLine.AddIntOpt( 'go' ,go  );		//	go[0|1]				_CAÕI[i[EBhE̎w
//			CmdLine.AddIntOpt( 'gp' ,gp  );		//	gp[0|1]				EBhE Disable ɂȂ
//			CmdLine.AddStrOpt( 'gr' ,gr  );		//	gr[<t@C>]	ύXt@C
//			CmdLine.AddIntOpt( 'gs' ,gs  );		//	gs[<TCY>]		wb_TCY̎w
//			CmdLine.AddIntOpt( 'gu' ,gu  );		//	gu[0|1]				WinSFXCDosSFX ɑSẴt@Ci[
//			CmdLine.AddIntOpt( 'gw' ,gw  );		//	gw[0|1|2|3|4]		WinSFX32/WinSFX32M 쐬
//			CmdLine.AddIntOpt( 'gya',gya );		//	gya[0|1]				  [-gya1]
//			CmdLine.AddIntOpt( 'gyc',gyc );		//	gyc[0|1]				^CX^v`FbN̏ȗ  [-gyc1]
//			CmdLine.AddStrOpt( 'gyd',gyd );		//	gyd<fBNg>	𓀐fBNgw
//			CmdLine.AddStrOpt( 'gye',gye );		//	gye<R}h>		sR}hw
//			CmdLine.AddIntOpt( 'gyo',gyo );		//	gyo[0|1]				㏑w(㏑mFsȂ)  [-gyo0]
//			CmdLine.AddIntOpt( 'gyq',gyq );		//	gyq[0|1]				sw  [-gyq0]
//			CmdLine.AddIntOpt( 'gys',gys );		//	gys[0|1]				₃`FbNs  [-gys0]
//			CmdLine.AddStrOpt( 'gyt',gyt );		//	gyt<^Cg>		𓀐fBNg^Cg̐ݒ
//			CmdLine.AddStrOpt( 'gyw',gyw );		//	gyw<^Cg>		_CAÕ^Cg̐ݒ
//			CmdLine.AddIntOpt( 'gyx',gyx );		//	gyx[0|1]				fBNg̕s  [-gyx0]

			CmdLine.AddPath1 ( 'o',BaseDir );

			CmdLine.Add( UserOptions );

			CmdLine.AddFName1( '',ArchiveFileName );

			AddFileSpec2( CmdLine,Options,FileList,UseResFile );

			if( Cmd = 'x' )and( x = 0 ) then Cmd := 'e';
			result := cmd + CmdLine.Str;
		finally
			CmdLine.Free;
		end;
	end;
end;

function TSevenZip32.FindOpen( Handle:HWND;ArchiveFileName:string;dwMode:DWORD ):THARC;
begin
	result:= FArchiver.OpenArchive( Handle,PChar( ExpandFileName( ArchiveFileName )),dwMode );
end;

function TSevenZip32.FindClose( hArc:THArc ):integer;
begin
	result := FArchiver.CloseArchive( hArc );
end;

function TSevenZip32.FindFirst( hArc:THArc;var IndivisualInfo:TIndivisualInfo;FileMask:string ):integer;
begin
	result := FArchiver.FindFirst( hArc,PChar( FileMask ),@IndivisualInfo );
end;

function TSevenZip32.FindNext( hArc:THArc;var IndivisualInfo:TIndivisualInfo ):integer;
begin
	result := FArchiver.FindNext( hArc,@IndivisualInfo )
end;

function IsSevenZipArchive( ArchiveFileName:string ):boolean;
var
	hArc:  THARC;
begin
	try
		LoadDLL;
		ArchiveFileName := ExpandFileName( ArchiveFileName );
{$ifdef ENABLEBUGFIX001}
		if FArchiver.CheckArchive( PChar( ArchiveFileName ),CHECKARCHIVE_ALL ) <> 0	// Ƀ`FbN
		then begin
{$endif}
			hArc := FArchiver.OpenArchive( 0,PAnsiChar( ArchiveFileName ),M_REGARDLESS_INIT_FILE+M_ERROR_MESSAGE_OFF );
			FArchiver.CloseArchive( hArc );
			result := ( hArc <> 0 );
{$ifdef ENABLEBUGFIX001}
		end else begin
			result := False;
		end;
{$endif}
	except
		result := false;
	end;
end;

end.
