// A[JCoR|[lg for Delphi/C++Builder
// Common Archivers Component for Delphi/C++Builder
// Copyright(C) NORG1964/M.Yoneda 1997,1998,1999,2000
//
// TAR32֘AW[	TAR32.PAS
//
// v1.10:Jo[W
// v1.11:eNX̃\bh錾̌
//       svϐ̐錾폜
// v1.12:TArchiveFile  Output/OutputSize vpeBǉ
//       tgz/zip `̈kxIvV( jm )
//       tar NɎɃtH[JX߂ǉ
//       \bh̎኱ύX
// v1.13:uses ߂sgpjbg Forms OȂĂ
//       \bh̎኱ύX
// v1.14:TGZ ̎ȉ𓀌`쐬@\T|[gJn|TAR32.DLL 0.31 ȍ~Kv
//       BZ2 `ɂ̃T|[gJn|TAR32.DLL 0.40 ȍ~Kv
// v1.16:{Ɏȉ𓀏ɂ쐬ł悤ɂ
//       ȉ𓀏ɂ̔ύX
// v1.17:LoadDll/FreeDll/IsXXXArchive ̍\ύX
// v1.20:ȉ𓀏ɍ쐬pXw@\ǉ
// v1.22:o߃CxgT|[gǉ
// v1.23:CheckArchive \bhǉ
//       ȃ\bh̉
// v1.25:ZIP32J.DLLł̖O"["܂ރt@Cւ̑Ή
// v1.28:WJ@\̃T|[gǉ
//	      CheckArchive \bh̖߂ľ^ύX
// v1.30:e\bh FileList ̌^ύX
// v1.32:IsSetOwnerWinow/KillOwnerWindow ̎ύX
// v1.35:TTar32.Tar  CmdLine ĂȂs̏C
// v1.38:DLL ̃Gg|Cg̎擾@ύX
// v1.44:SFX ɕKvȃt@CȂہAESfxNoRequiredFile 
//       O𔭐悤ɂ
// v1.48:gy nIvṼRgǉ
//
unit TAR32;

interface

uses Windows,SysUtils,Classes,Archives;

const
	//	tar ֘ȀɌ`
	ARCHIVETYPE_TAR      = 1;	//	TAR`
	ARCHIVETYPE_TARGZ    = 2;	//	GZ(TGZ)`
	ARCHIVETYPE_TARZ     = 3;	//	TAR.Z(TAZ)`
	ARCHIVETYPE_GZ       = 4;	//	GZ`
	ARCHIVETYPE_Z        = 5;	//	Z`
	ARCHIVETYPE_TARBZ2   = 6;	//	TAR.BZ2`
	ARCHIVETYPE_BZ2      = 7;	//	BZ2`

type
	TTar32 = class( TArchiver )
	protected
		class procedure LoadDll; override;
		class procedure FreeDll; override;

	protected
		function BuildCmdLine( Cmd,ArchiveFileName:string;Options:TArchiverOptions;Path:String;FileList:array of const;UseResFile:boolean ):String;

		function FindOpen ( Handle:HWND;ArchiveFileName:string;dwMode:DWORD ):THARC; override;
		function FindFirst( hArc:THArc;var IndivisualInfo:TIndivisualInfo;FileMask:string ):integer; override;
		function FindNext ( hArc:THArc;var IndivisualInfo:TIndivisualInfo                 ):integer; override;
		function FindClose( hArc:THArc                                                    ):integer; override;

	public
		function tar( Handle:HWND;CmdLine:string;var Output:string ):integer;
		function UnpackFiles  ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;DstPath:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer; override;
		function PackFiles    ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer; override;
//		function RemoveItems  ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer; override;
		function MakeSfx      ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;DstPath:String                                           ;var Output:string ):Integer; override;
		function UnpackToMem  ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;FileName:string;lpvBuffer:LPVOID;dwSize:DWORD;lpdwWriteSize:LPDWORD         ):Integer; override;
		function CheckArchive ( ArchiveFileName:string;CheckMode:integer;CheckOptions:integer ):DWORD; override;

		function SetOwnerWindowEx ( Handle:HWND;lpArcProc:LPARCHIVERPROC ):boolean; override;
		function KillOwnerWindowEx( Handle:HWND                          ):boolean; override;
	end;

	TTgz32 = class( TTar32 )
	end;

	TBZ232 = class( TTar32 )
	end;

	function IsTarArchive( ArchiveFileName:string ):TArchiverType;

implementation

uses
	Filters;

//---------------------------------------------------------------------
var
	FArchiver:		TArchiverDLL;

procedure LoadDll;
begin
	if Assigned( FArchiver ) then exit;
	FArchiver := TArchiverDll.Create( 'tar/tgz/taz/bz2 `','TAR32.DLL','Tar' );
	FArchiver.LoadDLL;
end;

procedure FreeDll;
begin
	FArchiver.Free;
	FArchiver := nil;
end;

//---------------------------------------------------------------------
class procedure TTar32.LoadDll;
begin
	Tar32.LoadDll;
end;

class procedure TTar32.FreeDll;
begin
	Tar32.FreeDll;
end;

function TTar32.UnpackFiles( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;DstPath:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer;
begin
	FCmdLine := BuildCmdLine( 'x',ArchiveFileName,Options,DstPath,FileList,ruOnUnpack in Options.ResFileUsage );
	result := Tar( Handle,FCmdLine,Output );
end;

function TTar32.PackFiles( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer;
begin
	FCmdLine := BuildCmdLine( 'c',ArchiveFileName,Options,BaseDir,FileList,ruOnPack in Options.ResFileUsage );
	result := Tar( Handle,FCmdLine,Output );
end;

//	function TTar32.RemoveItem( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer;
//	begin
//	end;

function TTar32.MakeSfx( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;DstPath:String;var Output:string ):Integer;
var
	SfxName:	string;
	SfxHead:	TFileStream;
	SfxFile:	TFileStream;
	ArcFile:	TFileStream;
	P:			PAnsiChar;
	TarSef:	array[0..511] of char;
begin
	if Self is TBZ232
	then raise EArchiver.Create( 'BZ2 `ɂ͎ȉ𓀌`ɂł܂B' );

	P := nil;
	if SearchPath( nil,'kmtarsef.exe',nil,SizeOf( TarSef ),TarSef,P ) = 0
	then raise ESfxNoRequiredFile.Create( 'tar/tgz','','kmtarsef.exe' );

	SfxName := ChangeFileExt( ArchiveFileName,'.EXE' );
	if DstPath <> ''
	then begin
		SfxName := ExtractFileName( SfxName );
		SfxName := MakeFileName( DstPath,SfxName );
	end;

	ArcFile := TFileStream.Create( ArchiveFileName ,fmOpenRead+fmShareDenyWrite );
	SfxFile := TFileStream.Create( SfxName         ,fmCreate                    );
	SfxHead := TFileStream.Create( TarSef          ,fmOpenRead+fmShareDenyWrite );
	try
		SfxFile.CopyFrom( SfxHead,0 );
		SfxFile.CopyFrom( ArcFile,0 );
	finally
		ArcFile.Free;
		SfxFile.Free;
		SfxHead.Free;
	end;

	Result := 0;
end;

function TTar32.UnpackToMem( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;FileName:string;lpvBuffer:LPVOID;dwSize:DWORD;lpdwWriteSize:LPDWORD ):Integer;
begin
	FCmdLine := BuildCmdLine( '',ArchiveFileName,Options,'',[FileName],false );
	result := FArchiver.ExtractMem( Handle,PChar( FCmdLine ),lpvBuffer,dwSize,nil,nil,lpdwWriteSize );
end;

function TTar32.CheckArchive( ArchiveFileName:string;CheckMode:integer;CheckOptions:integer ):DWORD;
begin
	result := FArchiver.CheckArchive( PChar( ArchiveFileName ),CheckMode+CheckOptions );
end;

function TTar32.Tar( Handle:HWND;CmdLine:string;var Output:string ):integer;
begin
	result := FArchiver.ArchiverProc( Handle,PChar( CmdLine ),PAnsiChar( Output ),Length( Output ));
end;

function TTar32.BuildCmdLine( Cmd,ArchiveFileName:string;Options:TArchiverOptions;Path:String;FileList:array of const;UseResFile:boolean ):String;
var
	CmdLine:	TCmdOpt;
begin
	with Options do begin
		CmdLine := TCmdOpt.Create;
		CmdLine.Format := cfOuter;

//		CmdLine.Add( '-+' );			//	ɃWXg̐ݒ𖳎

		if a > 0 then CmdLine.Add( '-AH' );		//	a[0|1|2]				̍ČB
		if a = 0 then CmdLine.Add( '-I'  );		//	a[0|1|2]				̍ČB
//		CmdLine.AddIntOpt( 'c'  ,c   );			//	c[0|1]				^CX^vȗ
//		CmdLine.AddIntOpt( 'd'  ,d   );			//	d[0|1]				fBNg̊i[
//		CmdLine.AddIntOpt( 'e'  ,e   );			//	e[0|1]				TCY𔼕ɂĈk
//		CmdLine.AddIntOpt( 'f'  ,f   );			//	f[0|1]				fBXNcʃ`FbN̒~
//		CmdLine.AddIntOpt( 'h'  ,h   );			//	h[0|1|2|3]			wb_̌`w
//		CmdLine.AddIntOpt( 'i'  ,i   );			//	i[0|1|2]				t@CIő啶Ə
//		CmdLine.AddIntOpt( 'l'  ,l   );			//	l[0|1|2]				WJÕt@C̕\@̕ύX
//		CmdLine.AddIntOpt( 'm'  ,m   );			//	m[0|1|2]				 yes Ɖ

		if not CallbackEnabled
		then begin										//	n[0|1]				WJ󋵃_CAO\̗}~
			if n > 0 then CmdLine.Add( '--display-dialog=0' );
		end;

		if o > 0 then CmdLine.Add( '-g' )	;	//	o[0|1|2]				`ŏɂ쐬
															//	### TAR `ł `Ƃ POSIX ݊Ƃ ###
		CmdLine.AddIntOpt( '-check-all-path=',p );
															//	p[0|1|2]				SpXōv
//		CmdLine.AddIntOpt( 'r'  ,r   );			//	r[0|1|2]				ċAI
//		CmdLine.AddIntOpt( 's'  ,s   );			//	s[0|1]				XLbv\̗}
//		CmdLine.AddIntOpt( 't'  ,t   );			//	t[0|1]				ɂ̍XV̎w

//		CmdLine.AddIntOpt( 'u'  ,u   );			//	u[0|1]				t@C̍XViV́j
//		CmdLine.AddPathName( 'w'  ,w   );		//	w[0|1|<Dir>]		ƗpfBNg̎w
		CmdLine.AddIntOpt( '-use-directory=',x );
															//	x[0|1]				fBNgLɂ

//		CmdLine.AddIntOpt( 'y'  ,y   );			//	y[0|1]				SĂ̎ yes Ɖ
//		CmdLine.AddIntOpt( 'z'  ,z   );			//	z[0|1|2|<gq>]	kt@C̎w			###gq̓T|[gȂ###
//		CmdLine.AddIntOpt( 'jc' ,jc  );			//	jc[0|1]				jwb_𖳎
//		CmdLine.AddIntOpt( 'jd' ,jd  );			//	jd[<TCY>]		fBXN̋󂫗eʂmF
//		CmdLine.AddIntOpt( 'je' ,je  );			//	je[<TCY>]		Huffman obt@̑傫w
//		CmdLine.AddIntOpt( 'jf' ,jf  );			//	jf[0|1]				[gL̍폜
//		CmdLine.AddIntOpt( 'jh' ,jh  );			//	jh[0|1]				WindowsNT/95 p̃}[Nɂɕt
//		CmdLine.AddIntOpt( 'ji' ,ji  );			//	ji[0|1]				Zt@CŊi[

//		CmdLine.AddIntOpt( 'jm' ,jm  );			//	jm[0|1|2|3|4]		k`w
		if Self is TTgz32
		then begin
			if jm < 1
			then CmdLine.Add( '-z' )				//	lw
			else CmdLine.AddIntOpt( 'z',jm );	//	x𖾎w肷
		end;
		if Self is TBZ232
		then begin
			if jm < 1
			then CmdLine.Add( '-B' )				//	lw
			else CmdLine.AddIntOpt( 'B',jm );	//	x𖾎w肷
		end;

//		CmdLine.AddIntOpt( 'jn' ,jn  );			//	jn[0|1]				VKt@Ĉ
//		CmdLine.AddStrOpt( 'jo' ,jo  );			//	jo[<w>]		YYMMDDHHMMSS ̓tȍ~
//		CmdLine.AddStrOpt( 'job',job );			//	job[<w>]	YYMMDDHHMMSS ̓tȑO
//		CmdLine.AddIntOpt( 'jp' ,jp  );			//	jp[0|1]				io[vOXEo[ŕ\
//		CmdLine.AddIntOpt( 'jr' ,jr  );			//	jr[0|1]				t@C̒u
//		CmdLine.AddIntOpt( 'jss',jss );			//	jss[0|1]				kt@CI[vG[𖳎BʏCkɈkΏۃt@
//		CmdLine.AddIntOpt( 'jw' ,jw  );			//	jw[0|1|2|3|4]		WinSFX/WinSFXM 쐬
//		CmdLine.AddLstOpt( 'jx' ,jx  );			//	jx[<t@C>]	Ot@C
//		CmdLine.AddIntOpt( 'jyc',jyc );			//	jyc[0|1]				fBNg쐬̊mFȗ
//		CmdLine.AddIntOpt( 'jyd',jyd );			//	jyd[0|1]				t@C폜̊mFȗ
//		CmdLine.AddIntOpt( 'jyk',jyk );			//	jyk[0|1]				gpłfBXNeʂ̊mF̏ȗ
//		CmdLine.AddIntOpt( 'jyn',jyn );			//	jyn[0|1]				Vt@C̗v̏ȗ
//		CmdLine.AddIntOpt( 'jyo',jyo );			//	jyo[0|1]				t@Cւ̏㏑mF̏ȗ
//		CmdLine.AddStrOpt( 'jz' ,jz  );			//	jz[<t@C>]	t@C߂̃t@C
//		CmdLine.AddIntOpt( 'ga' ,ga  );			//	ga[0|1]				ݕs𖳎
//		CmdLine.AddIntOpt( 'gd' ,gd  );			//	gd[0|1]				]ȃf[^̍폜
//		CmdLine.AddIntOpt( 'ge' ,ge  );			//	ge[0|1]				ŏ̊gqF
//		CmdLine.AddIntOpt( 'gf' ,gf  );			//	gf[0|1|2]			łɂt@C̍XV
//		CmdLine.AddIntOpt( 'gj' ,gj  );			//	gj[0|1]				x ߂ e ߂ƓlƌȂ
//		CmdLine.AddIntOpt( 'gm' ,gm  );			//	gm[0|1]				G[bZ[W\̗}~
//		CmdLine.AddIntOpt( 'gn' ,gn  );			//	gn[0|1|2]			WJt@C̍vTCY 100% ƂiOt̕\
//		CmdLine.AddIntOpt( 'go' ,go  );			//	go[0|1]				_CAÕI[i[EBhE̎w
//		CmdLine.AddIntOpt( 'gp' ,gp  );			//	gp[0|1]				EBhE Disable ɂȂ
//		CmdLine.AddIntOpt( 'gr' ,gr  );			//	gr[<t@C>]	ύXt@C
//		CmdLine.AddIntOpt( 'gs' ,gs  );			//	gs[<TCY>]		wb_TCY̎w
//		CmdLine.AddIntOpt( 'gu' ,gu  );			//	gu[0|1]				WinSFXCDosSFX ɑSẴt@Ci[
//		CmdLine.AddIntOpt( 'gw' ,gw  );			//	gw[0|1|2|3|4]		WinSFX32/WinSFX32M 쐬
//		CmdLine.AddIntOpt( 'gya',gya );			//	gya[0|1]				  [-gya1]
//		CmdLine.AddIntOpt( 'gyc',gyc );			//	gyc[0|1]				^CX^v`FbN̏ȗ  [-gyc1]
//		CmdLine.AddStrOpt( 'gyd',gyd );			//	gyd<fBNg>	𓀐fBNgw
//		CmdLine.AddStrOpt( 'gye',gye );			//	gye<R}h>		sR}hw
//		CmdLine.AddIntOpt( 'gyo',gyo );			//	gyo[0|1]				㏑w(㏑mFsȂ)  [-gyo0]
//		CmdLine.AddIntOpt( 'gyq',gyq );			//	gyq[0|1]				sw  [-gyq0]
//		CmdLine.AddIntOpt( 'gys',gys );			//	gys[0|1]				₃`FbNs  [-gys0]
//		CmdLine.AddStrOpt( 'gyt',gyt );			//	gyt<^Cg>		𓀐fBNg^Cg̐ݒ
//		CmdLine.AddStrOpt( 'gyw',gyw );			//	gyw<^Cg>		_CAÕ^Cg̐ݒ
//		CmdLine.AddIntOpt( 'gyx',gyx );			//	gyx[0|1]				fBNg̕s  [-gyx0]

		CmdLine.Add( UserOptions );

		if ArchiveFileName <> ''
		then begin
			CmdLine.AddFName1( 'f',ArchiveFileName );
		end;
		if Path <> ''
		then begin
			CmdLine.AddPath1( 'o',Path );
		end;

		AddFileSpec2( CmdLine,Options,FileList,UseResFile );

		result := Cmd + CmdLine.Str;
		CmdLine.Free;
	end;
end;

function TTar32.FindOpen( Handle:HWND;ArchiveFileName:string;dwMode:DWORD ):THARC;
begin
	result:= FArchiver.OpenArchive( Handle,PChar( ExpandFileName( ArchiveFileName )),dwMode );
end;

function TTar32.FindClose( hArc:THArc ):integer;
begin
	result := FArchiver.CloseArchive( hArc );
end;

function TTar32.FindFirst( hArc:THArc;var IndivisualInfo:TIndivisualInfo;FileMask:string ):integer;
begin
	result := FArchiver.FindFirst( hArc,PChar( FileMask ),@IndivisualInfo );
end;

function TTar32.FindNext( hArc:THArc;var IndivisualInfo:TIndivisualInfo ):integer;
begin
	result := FArchiver.FindNext( hArc,@IndivisualInfo )
end;

function TTar32.SetOwnerWindowEx( Handle:HWND;lpArcProc:LPARCHIVERPROC ):boolean;
begin
	inherited SetOwnerWindowEx( Handle,lpArcProc );
	result := FArchiver.SetOwnerWindowEx( Handle,lpArcProc );
end;

function TTar32.KillOwnerWindowEx( Handle:HWND ):boolean;
begin
	result := FArchiver.KillOwnerWindowEx( Handle );
	inherited KillOwnerWindowEx( Handle );
end;

{
function IsTarArchive( ArchiveFileName:string ):boolean;
var
	hArc:					THARC;
	IndivisualInfo:	TIndivisualInfo;
begin
	result := false;
	try
		hArc := FArchiver.OpenArchive( 0,PAnsiChar( ExpandFileName( ArchiveFileName )),M_REGARDLESS_INIT_FILE+M_ERROR_MESSAGE_OFF );
		if hArc <> 0
		then begin
			result := FArchiver.FindFirst( hArc,'*.*',@IndivisualInfo )=0;
			FArchiver.CloseArchive( hArc );
		end;
	except
		result := false;
	end;
end;
}
function IsTarArchive( ArchiveFileName:string ):TArchiverType;
var
	ArchiverType:	integer;
begin
	try
		LoadDLL;
		ArchiverType := FArchiver.GetArchiveType( PAnsiChar( ArchiveFileName ));
		case ArchiverType of
			//	񈳏ǩ`
			ARCHIVETYPE_TAR:     //	TAR`
				result := atTar;

			//	kꂽ` ( BZ2LIB.DLLFsv )
			ARCHIVETYPE_TARGZ,   //	GZ(TGZ)`
			ARCHIVETYPE_TARZ,    //	TAR.Z(TAZ)`
			ARCHIVETYPE_GZ,      //	GZ`
			ARCHIVETYPE_Z:       //	Z`
				result := atTGZ;

			//	kꂽ` ( BZ2LIB.DLLFKv )
			ARCHIVETYPE_TARBZ2,  //	TAR.BZ2`
			ARCHIVETYPE_BZ2:     //	BZ2`
				result := atBZ2;

			//	`s
			else
				result := atNone;
		end;
	except
		result := atNone;
	end;
end;

end.
