// A[JCoR|[lg for Delphi/C++Builder
// Common Archivers Component for Delphi/C++Builder
// Copyright(C) NORG1964/M.Yoneda 1997-2002
//
// ZIP32֘AW[	ZIP32.PAS
//
// v1.00:Jo[W
// v1.01:Open/Close \bh FindOpen/FindClose ɉ
// v1.02:t@CXgp[^̌^ TStrings ɕύX
//       ^Cg̃Rg኱ύX
// v1.03:LMZIP32ւ̑ΉFꗗ擾\
//       Delphi 3 ɑΉ
// v1.04:LMZIP32ւ̑ΉFɂ̍쐬\
// v1.05:ɓACe폜p\bhǉ
//       LoadDll/FreeDll ̍\ύX
//       Ƀt@C@\ǉ
// v1.06:ɑ상\bh̖߂lss̑΍
// v1.09:Update/ExtractTo \bh PackTo/UnpackTo ɉ
//       o߃_CAO\IvV
//       R}hC̕sC
// v1.11:eNX̃\bh錾̌
//       svϐ̐錾폜
// v1.12:TArchiveFile  Output/OutputSize vpeBǉ
//       ZIP32J.DLL ̃T|[gǉ
//       \bh̎኱ύX
// v1.13:UNZIP32.DLL ݂Ă ZIP ɂ𓀂łȂs̏C
//       \bh̎኱ύX
// v1.15:ZIP32J ł̈kxIvV̌
// v1.16:rEa IvV̐@ǉ^
//       삵Ȃ̂ jo/job IvṼT|[gfO
// v1.17:ZIP32J 0.20 ɑΉ|LMZIP32.DLL Ȃňꗗ擾\
//       LoadDll/FreeDll/IsXXXArchive ̍\ύX
//       LMZIP32.DLL ňkłȂȂĂ̂C
// v1.19:ZIP`ɂ̎ȉ𓀏ɍ쐬@\
// v1.20:ȉ𓀏ɍ쐬pXw@\ǉ
// v1.21:LoadDll/FreeDll ̉xύX
// v1.22:o߃CxgT|[gǉ
// v1.23:CheckArchive \bhǉ
//       ȃ\bh̉
// v1.24:R}hC̃pXf~^'/'ɂ
// v1.25:ZIP32J.DLLł̖O"["܂ރt@Cւ̑Ή
// v1.28:WJ@\̃T|[gǉ
//	      CheckArchive \bh̖߂ľ^ύX
// v1.30:e\bh FileList ̌^ύX
// v1.32:IsZipArchive ̎ύX
//       IsSetOwnerWinow/KillOwnerWindow ̎ύX
// v1.33:tB^ODLLL`FbN̎ǉ
// v1.35:TZip32.Zip/TZip32.Unzip  CmdLine ĂȂs̏C
// v1.37:ꎞfBNgwIvṼT|[gǉ
// v1.38:DLL ̃Gg|Cg̎擾@ύX
// v1.40:ZIP `ɂǂ̔菈
// v1.41:Pڂ '-' ̃t@Cւ̑Ήǉ
// v1.44:SFX ɕKvȃt@CȂہAESfxNoRequiredFile 
//       O𔭐悤ɂ
// v1.48:gy nIvṼRgǉ
//
unit ZIP32;

interface

uses Windows,SysUtils,Classes,Archives;

type
	TZip32 = class( TArchiver )
	protected
		class procedure LoadDll; override;
		class procedure FreeDll; override;

	protected
		function  BuildUnZipCmd( Cmd,ArchiveFileName:string;Options:TArchiverOptions;Path:String;FileList:array of const;UseResFile:boolean ):String;
		function  BuildLMZipCmd( Cmd,ArchiveFileName:string;Options:TArchiverOptions;Path:String;FileList:array of const;UseResFile:boolean ):String;
		function  BuildZipCmd  ( Cmd,ArchiveFileName:string;Options:TArchiverOptions;Path:String;FileList:array of const;UseResFile:boolean ):String;

		function  FindOpen ( Handle:HWND;ArchiveFileName:string;dwMode:DWORD ):THARC; override;
		function  FindFirst( hArc:THArc;var IndivisualInfo:TIndivisualInfo;FileMask:string ):integer; override;
		function  FindNext ( hArc:THArc;var IndivisualInfo:TIndivisualInfo                 ):integer; override;
		function  FindClose( hArc:THArc                                                    ):integer; override;

//		function  FileSpec( FileName:string ):String; override;

	public
		constructor Create;
		function Zip          ( Handle:HWND;CmdLine:string;var Output:string ):Integer;
		function Unzip        ( Handle:HWND;CmdLine:string;var Output:string ):Integer;
		function UnpackFiles  ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;DstPath:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer; override;
		function PackFiles    ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer; override;
		function RemoveItems  ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer; override;
		function UpdateArchive( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer; override;
		function MakeSfx      ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;DstPath:String                                     ;var Output:string ):Integer; override;
		function UnpackToMem  ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;FileName:string;lpvBuffer:LPVOID;dwSize:DWORD;lpdwWriteSize:LPDWORD   ):Integer; override;
		function CheckArchive (             ArchiveFileName:string;CheckMode:integer;CheckOptions:integer ):DWORD; override;
		function SetOwnerWindowEx ( Handle:HWND;lpArcProc:LPARCHIVERPROC ):boolean; override;
		function KillOwnerWindowEx( Handle:HWND                          ):boolean; override;
	end;

	function IsZipArchive( ArchiveFileName:string ):boolean;

implementation

uses
	Filters;

const
	UNZIP32DLL = 'UNZIP32.DLL';
	LMZIP32DLL = 'LMZIP32.DLL';
	ZIP32JDLL  = 'ZIP32J.DLL';

type
	TZipDll = class( TCustomArchiverDll )
	private
		function GetZipProc( var EntryPoint:FARPROC;hDLL1,hDLL2,hDLL3:HMODULE;ProcName:string;RaiseException:boolean ):boolean;
		function UnZip(_hwnd:HWND;_lpszCmdLine,_lpszOutput:PAnsiChar;_dwSize:DWORD ):integer;
		function Zip  (_hwnd:HWND;_lpszCmdLine,_lpszOutput:PAnsiChar;_dwSize:DWORD ):integer;
	protected
		hUnZip32:		THandle;
		hLMZip32:		THandle;
		hZip32J:			THandle;
		FZip:				FARPROC;
		FUnZip:			FARPROC;
	public
		procedure LoadDll; override;
		procedure FreeDll; override;
//		function ArchiverProc( _hwnd:HWND;_lpszCmdLine:PAnsiChar;_lpszOutput:PAnsiChar;_dwSize:DWORD ):integer; override;
		function CheckArchive( lpszFileName:PAnsiChar;iMode:integer ):DWORD; override;
		function CloseArchive( hArc:THARC ):integer; override;
		function ExtractMem( Handle:HWND;lpszCmdLine:PAnsiChar;lpvBuffer:LPBYTE;dwSize:DWORD;lpTime:ptime_t;lpwAttr:LPWORD;lpdwWriteSize:LPDWORD ): integer; override;
		function FindFirst( hArc:THArc;FileMask:string;IndivisualInfo:PIndivisualInfo ):integer; override;
		function FindNext( hArc:THArc;IndivisualInfo:PIndivisualInfo ):integer; override;
		function KillOwnerWindowEx( Handle:HWND ):BOOL; override;
		function OpenArchive( Handle:HWND;ArchiveFileName:string;dwMode:DWORD ): THARC; override;
		function SetOwnerWindowEx( Handle:HWND;lpArcProc:LPARCHIVERPROC ):BOOL; override;
//		function GetArchiveType( lpszFileName:PAnsiChar ):integer; virtual;
	protected
		function GetWriteTimeEx( hArc:THArc;var lpLastWriteTime:TFileTime ):BOOL; override;
		function GetCreateTimeEx( hArc:THArc;var lpCreateTime:TFileTime ):BOOL; override;
		function GetAccessTimeEx( hArc:THArc;var lpAccessTime:TFileTime ):BOOL; override;
	end;

//---------------------------------------------------------------------
var
	FArchiver:	TZipDll;

procedure LoadDll;
begin
	if Assigned( FArchiver ) then exit;
	FArchiver := TZipDll.Create;
	FArchiver.LoadDLL;
end;

procedure FreeDll;
begin
	FArchiver.Free;
	FArchiver := nil;
end;

//---------------------------------------------------------------------
procedure TZipDll.LoadDll;
begin
	if hUnzip32 =  0 then hUnZip32 :=  Loadlibrary( UNZIP32DLL );
	if hZip32J  =  0 then hZip32J  :=  Loadlibrary( ZIP32JDLL  );
	if hLMZip32 =  0 then hLMZip32 :=  Loadlibrary( LMZIP32DLL );
	if hUnZip32 <> 0 then exit;
	if hZip32J  <> 0 then exit;
	if hLMZip32 <> 0 then exit;
end;

procedure TZipDll.FreeDll;
	procedure Free( var hDLL:THandle );
	begin
		if hDLL = 0 then exit;
		FreeLibrary( hDLL ) ;
		hDLL := 0;
	end;
begin
	Free( hUnZip32 );
	Free( hLMZip32 );
	Free( hZip32J  );
	FZip						   := nil;
	FUnZip					   := nil;
	inherited;
end;

function TZipDll.GetZipProc( var EntryPoint:FARPROC;hDLL1,hDLL2,hDLL3:HMODULE;ProcName:string;RaiseException:boolean ):boolean;
	function ZipProc( hDLL:HMODULE;ProcName:string ):FARPROC;
	begin
		result := nil;
		if hDLL = 0 then exit;
		if hDLL = hLMZip32
		then begin
			if ( ProcName[3] = 'Z' ) then ProcName[3] := 'z';
		end;
		GetProcAddr( result,hDLL,PChar( ProcName ),false );
	end;
begin
	result := true;

	EntryPoint := ZipProc( hDLL1,PChar( ProcName ));
	if EntryPoint <> nil then exit;

	EntryPoint := ZipProc( hDLL2,PChar( ProcName ));
	if EntryPoint <> nil then exit;

	EntryPoint := ZipProc( hDLL3,PChar( ProcName ));
	if EntryPoint <> nil then exit;

	if RaiseException then raise EEntryNotFound.Create( Format( '%0:s ̃Gg DLL Ɍ܂łB',[ProcName] ));
	result := false;
end;

function TZipDll.Zip( _hwnd:HWND;_lpszCmdLine:PAnsiChar;_lpszOutput:PAnsiChar;_dwSize:DWORD ):integer;
begin
	LoadDll;
	GetZipProc( FZip,hZip32J,hLMZip32,0,'Zip',true );
	if _dwSize = 0 then _lpszOutput := nil;
	result := TArcDLLArchiverProc( FZip )( _hwnd,_lpszCmdLine,_lpszOutput,_dwSize );
end;

function TZipDll.UnZip( _hwnd:HWND;_lpszCmdLine:PAnsiChar;_lpszOutput:PAnsiChar;_dwSize:DWORD ):integer;
begin
	LoadDll;
	GetZipProc( FUnZip,hUnZip32,hLMZip32,0,'UnZip',true );
	if _dwSize = 0 then _lpszOutput := nil;
	result := TArcDLLArchiverProc( FUnZip )( _hwnd,_lpszCmdLine,_lpszOutput,_dwSize );
end;

function TZipDll.OpenArchive( Handle:HWND;ArchiveFileName:string;dwMode:DWORD ):THARC;
begin
	LoadDll;
	GetZipProc( FOpenArchive,hLMZip32,hZip32J,hUnZip32,'UnZipOpenArchive',true );
	result := inherited OpenArchive( Handle,PChar( ArchiveFileName ),dwMode );
end;

function TZipDll.CloseArchive( hArc:THARC ):integer;
begin
	LoadDll;
	GetZipProc( FCloseArchive,hLMZip32,hZip32J,hUnZip32,'UnZipCloseArchive',true );
	result := inherited CloseArchive( hArc );
end;

function TZipDll.FindFirst( hArc:THArc;FileMask:string;IndivisualInfo:PIndivisualInfo ):integer;
begin
	LoadDll;
	GetZipProc( FFindFirst,hLMZip32,hZip32J,hUnZip32,'UnZipFindFirst',true );
	result := inherited FindFirst( hArc,FileMask,IndivisualInfo );
end;

function TZipDll.FindNext( hArc:THArc;IndivisualInfo:PIndivisualInfo ):integer;
begin
//	LoadDll;	xȂ̂ł߂
	GetZipProc( FFindNext,hLMZip32,hZip32J,hUnZip32,'UnZipFindNext',true );
	result := inherited FindNext( hArc,IndivisualInfo );
end;

function TZipDll.GetWriteTimeEx( hArc:THArc;var lpLastWriteTime:TFileTime ):BOOL;
begin
	GetZipProc( FGetWriteTimeEx,hLMZip32,hZip32J,hUnZip32,'UnzipGetWriteTimeEx',false );
	result := inherited GetWriteTimeEx( hArc,lpLastWriteTime );
end;

function TZipDll.GetCreateTimeEx( hArc:THArc;var lpCreateTime:TFileTime ):BOOL;
begin
	GetZipProc( FGetCreateTimeEx,hLMZip32,hZip32J,hUnZip32,'UnZipGetCreateTimeEx',false );
	result := inherited GetCreateTimeEx( hArc,lpCreateTime );
end;

function TZipDll.GetAccessTimeEx( hArc:THArc;var lpAccessTime:TFileTime ):BOOL;
begin
	GetZipProc( FGetAccessTimeEx,hLMZip32,hZip32J,hUnZip32,'UnZipGetAccessTimeEx',false );
	result := inherited GetAccessTimeEx( hArc,lpAccessTime );
end;

function TZipDll.CheckArchive( lpszFileName:PAnsiChar;iMode:integer ):DWORD;
begin
	LoadDll;
	GetZipProc( FCheckArchive,hUnZip32,hLMZip32,hZip32J,'UnZipCheckArchive',true );
	result := inherited CheckArchive( lpszFileName,iMode );
end;

function TZipDll.SetOwnerWindowEx( Handle:HWND;lpArcProc:LPARCHIVERPROC ):BOOL;
begin
	GetProcAddr( FSetOwnerWindowEx,hUnZip32,'UnZipSetOwnerWindowEx',true );
	result := inherited SetOwnerWindowEx( Handle,lpArcProc );
end;

function TZipDll.KillOwnerWindowEx( Handle:HWND ):BOOL;
begin
	GetProcAddr( FKillOwnerWindowEx,hUnZip32,'UnZipKillOwnerWindowEx',true );
	result := inherited KillOwnerWindowEx( Handle );
end;

function TZipDll.ExtractMem( Handle:HWND;lpszCmdLine:PAnsiChar;lpvBuffer:LPBYTE;dwSize:DWORD;lpTime:ptime_t;lpwAttr:LPWORD;lpdwWriteSize:LPDWORD ):integer;
begin
	GetZipProc( FExtractMem,hUnZip32,hLMZip32,hZip32J,'UnZipExtractMem',true );
	result := inherited ExtractMem( Handle,lpszCmdLine,lpvBuffer,dwSize,lpTime,lpwAttr,lpdwWriteSize );
end;

//---------------------------------------------------------------------
constructor TZip32.Create;
begin
	inherited Create;
//	FSepChar := '/';
end;

class procedure TZip32.LoadDll;
begin
	Zip32.LoadDll;
end;

class procedure TZip32.FreeDll;
begin
	Zip32.FreeDll;
end;

function TZip32.UnpackFiles( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;DstPath:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer;
begin
	if( FArchiver.hUnZip32 = 0 )and( FArchiver.hLMZip32 = 0 )
	then raise EArchiver.Create( 'ZIP `ɂ̉𓀂ɂ UNZIP32.DLL ܂ LMZIP32.DLL KvłB' );
	FCmdLine := BuildUnzipCmd( '-x',ArchiveFileName,Options,DstPath,FileList,UseResFile );
	result := Unzip( Handle,FCmdLine,Output );
end;

function TZip32.PackFiles( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer;
begin
	if FArchiver.hZip32J <> 0
	then begin
		FCmdLine := BuildZipCmd( '',ArchiveFileName,Options,BaseDir,FileList,UseResFile );
		result := Zip( Handle,FCmdLine,Output );
		exit;
	end;
	if FArchiver.hLMZip32 <> 0
	then begin
		FCmdLine := BuildLMZipCmd( '-ru',ArchiveFileName,Options,''{BaseDir},FileList,UseResFile );
		DeleteFile( ArchiveFileName );		//	ǉ悤ƂƃAvP[VG[̂ł炩ߍ폜
		result := Zip( Handle,FCmdLine,Output );
		exit;
	end;
	raise EArchiver.Create( 'ZIP `ɂ̍쐬ɂ ZIP32J.DLL ܂ LMZIP32.DLL KvłB' );
end;

function TZip32.RemoveItems( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer;
begin
	FCmdLine := BuildZipCmd( '-d',ArchiveFileName,Options,''{BaseDir},FileList,UseResFile );
	result := Zip( Handle,FCmdLine,Output );
end;

function TZip32.UpdateArchive( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer;
begin
	FCmdLine := BuildZipCmd( '-f',ArchiveFileName,Options,BaseDir,FileList,UseResFile );
	result := Zip( Handle,FCmdLine,Output );
end;

function TZip32.MakeSfx( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;DstPath:String;var Output:string ):Integer;
var
	SfxDat:	array[0..511] of char;
	SfxName:	string;
	SfxHead:	TFileStream;
	SfxFile:	TFileStream;
	ArcFile:	TFileStream;
	P:			PAnsiChar;
begin
	if FArchiver.hZip32J=0 then raise ESfxNoRequiredFile.Create( 'zip','','ZIP32J.DLL' );

	if Options.gw > 0
	then begin
		if SearchPath( nil,'sfx32gui.dat',nil,SizeOf( SfxDat ),SfxDat,P ) = 0
		then raise ESfxNoRequiredFile.Create( 'zip','Win32','sfx32gui.dat' );
	end else begin
		if SearchPath( nil,'sfx16.dat',nil,SizeOf( SfxDat ),SfxDat,P ) = 0
		then raise ESfxNoRequiredFile.Create( 'zip','DOS','sfx16.dat' );
	end;

	SfxName := ChangeFileExt( ArchiveFileName,'.EXE' );
	if DstPath <> ''
	then begin
		SfxName := ExtractFileName( SfxName );
		SfxName := MakeFileName( DstPath,SfxName );
	end;
	ArcFile := TFileStream.Create( ArchiveFileName,fmOpenRead+fmShareDenyWrite );
	SfxFile := TFileStream.Create( SfxName        ,fmCreate                    );
	SfxHead := TFileStream.Create( SfxDat         ,fmOpenRead+fmShareDenyWrite );
	try
		SfxFile.CopyFrom( SfxHead,0 );
		SfxFile.CopyFrom( ArcFile,0 );
	finally
		ArcFile.Free;
		SfxFile.Free;
		SfxHead.Free;
	end;

	FCmdLine := '-A '+SfxName;
	result := Zip( Handle,FCmdLine,Output );
end;

function TZip32.UnpackToMem( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;FileName:string;lpvBuffer:LPVOID;dwSize:DWORD;lpdwWriteSize:LPDWORD ):Integer;
var
	FileList:	TStringList;
begin
	FileList := TStringList.Create;
	try
		FileList.Add( FileName );
		FCmdLine := BuildUnzipCmd( '',ArchiveFileName,Options,'',[FileList],false );
		result := FArchiver.ExtractMem( Handle,PChar( FCmdLine ),lpvBuffer,dwSize,nil,nil,lpdwWriteSize );
	finally
		FileList.Free;
	end;
end;

function TZip32.CheckArchive( ArchiveFileName:string;CheckMode:integer;CheckOptions:integer ):DWORD;
begin
	result := FArchiver.CheckArchive( PChar( ArchiveFileName ),CheckMode );
end;

function TZip32.Unzip( Handle:HWND;CmdLine:string;var Output:string ):Integer;
begin
	result := FArchiver.UnZip( Handle,PAnsiChar( CmdLine ),PAnsiChar( Output ),Length( Output ));
end;

function TZip32.Zip( Handle:HWND;CmdLine:string;var Output:string ):Integer;
begin
	result := FArchiver.Zip( Handle,PAnsiChar( CmdLine ),PAnsiChar( Output ),Length( Output ));
end;

function TZip32.SetOwnerWindowEx( Handle:HWND;lpArcProc:LPARCHIVERPROC ):boolean;
begin
	result := FArchiver.SetOwnerWindowEx( Handle,lpArcProc );
	inherited SetOwnerWindowEx( Handle,lpArcProc );
end;

function TZip32.KillOwnerWindowEx( Handle:HWND ):boolean;
begin
	result := FArchiver.KillOwnerWindowEx( Handle );
	inherited KillOwnerWindowEx( Handle );
end;

function Zip32JFilter( FileName:string ):string;
var
	TmpStr:	string;
	Pos0:		Integer;
	Pos1:		Integer;
	Pos2:		Integer;
//	Pos3:		Integer;
	procedure Replace( Pos,Size:integer;NewString:string );
	begin
		Result := Result + Copy( TmpStr,1,Pos-1 ) + NewString;
		TmpStr := Copy( TmpStr,Pos+Size,MaxInt );
	end;
begin
	TmpStr := FileName;
	Result := '';
	if( Length( TmpStr ) > 0 )and( TmpStr[1]='-' ) then Replace( 1,1,'[-]' );
	while TmpStr <> '' do begin
		Pos1 := AnsiPos( '\',TmpStr );
		Pos2 := AnsiPos( '[',TmpStr );
//		Pos3 := AnsiPos( ']',TmpStr );

		Pos0 := MaxInt;
		if( Pos1 > 0 )and( Pos1 < Pos0 ) then Pos0 := Pos1;
		if( Pos2 > 0 )and( Pos2 < Pos0 ) then Pos0 := Pos2;
//		if( Pos3 > 0 )and( Pos3 < Pos0 ) then Pos0 := Pos3;
		if Pos0 = MaxInt then Break;

		if Pos1 = Pos0 then Replace( Pos1,1,'/'   );
		if Pos2 = Pos0 then Replace( Pos2,1,'[[]' );
//		if Pos3 = Pos0 then Replace( Pos3,1,'[]]' );
	end;
	Result := Result + TmpStr;
end;

function TZip32.BuildUnzipCmd( Cmd,ArchiveFileName:string;Options:TArchiverOptions;Path:String;FileList:array of const;UseResFile:boolean ):String;
var
	CmdLine:	TCmdOpt;
begin
	with Options do begin
		CmdLine := TCmdOpt.Create;
		try
			CmdLine.Filter := Zip32JFilter;

//			CmdLine.Add( '-+' );			//	ɃWXg̐ݒ𖳎

//			CmdLine.AddIntOpt( 'a'  ,a   );		//	a[0|1|2]				̍ČB
			if c=1 then CmdLine.Add( '-o' );		//	c[0|1]				^CX^vȗ
//			CmdLine.AddIntOpt( 'd'  ,d   );		//	d[0|1]				fBNg̊i[
//			CmdLine.AddIntOpt( 'e'  ,e   );		//	e[0|1]				TCY𔼕ɂĈk
//			CmdLine.AddIntOpt( 'f'  ,f   );		//	f[0|1]				fBXNcʃ`FbN̒~
//			CmdLine.AddIntOpt( 'h'  ,h   );		//	h[0|1|2|3]			wb_̌`w
//			CmdLine.AddIntOpt( 'i'  ,i   );		//	i[0|1|2]				t@CIő啶Ə
//			CmdLine.AddIntOpt( 'l'  ,l   );		//	l[0|1|2]				WJÕt@C̕\@̕ύX
//			CmdLine.AddIntOpt( 'm'  ,m   );		//	m[0|1|2]				 yes Ɖ
			if( n > 0 )or( CallbackEnabled )
			then CmdLine.Add( '--i' );				//	n[0|1]				WJ󋵃_CAO\̗}~
//			CmdLine.AddIntOpt( 'o'  ,o   );		//	o[0|1|2]				`ŏɂ쐬
//			CmdLine.AddIntOpt( 'p'  ,p   );		//	p[0|1|2]				SpXōv
//			CmdLine.AddIntOpt( 'r'  ,r   );		//	r[0|1|2]				ċAI
//			CmdLine.AddIntOpt( 's'  ,s   );		//	s[0|1]				XLbv\̗}
//			CmdLine.AddIntOpt( 't'  ,t   );		//	t[0|1]				ɂ̍XV̎w

//			CmdLine.AddIntOpt( 'u'  ,u   );		//	u[0|1]				t@C̍XViV́j
//			CmdLine.AddPath1 ( 'w'  ,w   );		//	w[0|1|<Dir>]		ƗpfBNg̎w
			if x=0 then CmdLine.Add( '-j' );		//	x[0|1]				fBNgLɂ
//			CmdLine.AddIntOpt( 'y'  ,y   );		//	y[0|1]				SĂ̎ yes Ɖ
//			CmdLine.AddIntOpt( 'z'  ,z   );		//	z[0|1|2|<gq>]	kt@C̎w			###gq̓T|[gȂ###
//			CmdLine.AddIntOpt( 'jc' ,jc  );		//	jc[0|1]				jwb_𖳎
//			CmdLine.AddIntOpt( 'jd' ,jd  );		//	jd[<TCY>]		fBXN̋󂫗eʂmF
//			CmdLine.AddIntOpt( 'je' ,je  );		//	je[<TCY>]		Huffman obt@̑傫w
//			CmdLine.AddIntOpt( 'jf' ,jf  );		//	jf[0|1]				[gL̍폜
//			CmdLine.AddIntOpt( 'jh' ,jh  );		//	jh[0|1]				WindowsNT/95 p̃}[Nɂɕt
//			CmdLine.AddIntOpt( 'ji' ,ji  );		//	ji[0|1]				Zt@CŊi[
//			CmdLine.AddIntOpt( 'jm' ,jm  );		//	jm[0|1|2|3|4]		k`w
//			CmdLine.AddIntOpt( 'jn' ,jn  );		//	jn[0|1]				VKt@Ĉ
//			CmdLine.AddStrOpt( 'jo' ,jo  );		//	jo[<w>]		YYMMDDHHMMSS ̓tȍ~
//			CmdLine.AddStrOpt( 'job',job );		//	job[<w>]	YYMMDDHHMMSS ̓tȑO
//			CmdLine.AddIntOpt( 'jp' ,jp  );		//	jp[0|1]				io[vOXEo[ŕ\
//			CmdLine.AddIntOpt( 'jr' ,jr  );		//	jr[0|1]				t@C̒u
//			CmdLine.AddIntOpt( 'jss',jss );		//	jss[0|1]				kt@CI[vG[𖳎BʏCkɈkΏۃt@
//			CmdLine.AddIntOpt( 'jw' ,jw  );		//	jw[0|1|2|3|4]		WinSFX/WinSFXM 쐬
//			CmdLine.AddLstOpt( 'jx' ,jx  );		//	jx[<t@C>]	Ot@C
//			CmdLine.AddIntOpt( 'jyc',jyc );		//	jyc[0|1]				fBNg쐬̊mFȗ
//			CmdLine.AddIntOpt( 'jyd',jyd );		//	jyd[0|1]				t@C폜̊mFȗ
//			CmdLine.AddIntOpt( 'jyk',jyk );		//	jyk[0|1]				gpłfBXNeʂ̊mF̏ȗ
//			CmdLine.AddIntOpt( 'jyn',jyn );		//	jyn[0|1]				Vt@C̗v̏ȗ
//			CmdLine.AddIntOpt( 'jyo',jyo );		//	jyo[0|1]				t@Cւ̏㏑mF̏ȗ
//			CmdLine.AddStrOpt( 'jz' ,jz  );		//	jz[<t@C>]	t@C߂̃t@C
//			CmdLine.AddIntOpt( 'ga' ,ga  );		//	ga[0|1]				ݕs𖳎
//			CmdLine.AddIntOpt( 'gd' ,gd  );		//	gd[0|1]				]ȃf[^̍폜
//			CmdLine.AddIntOpt( 'ge' ,ge  );		//	ge[0|1]				ŏ̊gqF
//			CmdLine.AddIntOpt( 'gf' ,gf  );		//	gf[0|1|2]			łɂt@C̍XV
//			CmdLine.AddIntOpt( 'gj' ,gj  );		//	gj[0|1]				x ߂ e ߂ƓlƌȂ
//			CmdLine.AddIntOpt( 'gm' ,gm  );		//	gm[0|1]				G[bZ[W\̗}~
//			CmdLine.AddIntOpt( 'gn' ,gn  );		//	gn[0|1|2]			WJt@C̍vTCY 100% ƂiOt̕\
//			CmdLine.AddIntOpt( 'go' ,go  );		//	go[0|1]				_CAÕI[i[EBhE̎w
//			CmdLine.AddIntOpt( 'gp' ,gp  );		//	gp[0|1]				EBhE Disable ɂȂ
//			CmdLine.AddIntOpt( 'gr' ,gr  );		//	gr[<t@C>]	ύXt@C
//			CmdLine.AddIntOpt( 'gs' ,gs  );		//	gs[<TCY>]		wb_TCY̎w
//			CmdLine.AddIntOpt( 'gu' ,gu  );		//	gu[0|1]				WinSFXCDosSFX ɑSẴt@Ci[
//			CmdLine.AddIntOpt( 'gw' ,gw  );		//	gw[0|1|2|3|4]		WinSFX32/WinSFX32M 쐬
//			CmdLine.AddIntOpt( 'gya',gya );		//	gya[0|1]				  [-gya1]
//			CmdLine.AddIntOpt( 'gyc',gyc );		//	gyc[0|1]				^CX^v`FbN̏ȗ  [-gyc1]
//			CmdLine.AddStrOpt( 'gyd',gyd );		//	gyd<fBNg>	𓀐fBNgw
//			CmdLine.AddStrOpt( 'gye',gye );		//	gye<R}h>		sR}hw
//			CmdLine.AddIntOpt( 'gyo',gyo );		//	gyo[0|1]				㏑w(㏑mFsȂ)  [-gyo0]
//			CmdLine.AddIntOpt( 'gyq',gyq );		//	gyq[0|1]				sw  [-gyq0]
//			CmdLine.AddIntOpt( 'gys',gys );		//	gys[0|1]				₃`FbNs  [-gys0]
//			CmdLine.AddStrOpt( 'gyt',gyt );		//	gyt<^Cg>		𓀐fBNg^Cg̐ݒ
//			CmdLine.AddStrOpt( 'gyw',gyw );		//	gyw<^Cg>		_CAÕ^Cg̐ݒ
//			CmdLine.AddIntOpt( 'gyx',gyx );		//	gyx[0|1]				fBNg̕s  [-gyx0]

			CmdLine.Add( UserOptions );

			AddFileSpec1( CmdLine,ArchiveFileName,Path );
			AddFileSpec2( CmdLine,Options,FileList,UseResFile );

			result := cmd + CmdLine.Str;
		finally
			CmdLine.Free;
		end;
	end;
end;

function TZip32.BuildLMZipCmd( Cmd,ArchiveFileName:string;Options:TArchiverOptions;Path:String;FileList:array of const;UseResFile:boolean ):String;
var
	CmdLine:	TCmdOpt;
begin
	with Options do begin
		CmdLine := TCmdOpt.Create;
		try
//			CmdLine.Add( '-+' );			//	ɃWXg̐ݒ𖳎

//			CmdLine.AddIntOpt( 'a'  ,a   );		//	a[0|1|2]				̍ČB
			if c=1 then CmdLine.Add( '-o' );		//	c[0|1]				^CX^vȗ
//			CmdLine.AddIntOpt( 'd'  ,d   );		//	d[0|1]				fBNg̊i[
//			CmdLine.AddIntOpt( 'e'  ,e   );		//	e[0|1]				TCY𔼕ɂĈk
//			CmdLine.AddIntOpt( 'f'  ,f   );		//	f[0|1]				fBXNcʃ`FbN̒~
//			CmdLine.AddIntOpt( 'h'  ,h   );		//	h[0|1|2|3]			wb_̌`w
//			CmdLine.AddIntOpt( 'i'  ,i   );		//	i[0|1|2]				t@CIő啶Ə
//			CmdLine.AddIntOpt( 'l'  ,l   );		//	l[0|1|2]				WJÕt@C̕\@̕ύX
//			CmdLine.AddIntOpt( 'm'  ,m   );		//	m[0|1|2]				 yes Ɖ
//			if n=1 then CmdLine.Add( '--i' );	//	n[0|1]				WJ󋵃_CAO\̗}~
//			CmdLine.AddIntOpt( 'o'  ,o   );		//	o[0|1|2]				`ŏɂ쐬
//			CmdLine.AddIntOpt( 'p'  ,p   );		//	p[0|1|2]				SpXōv
//			CmdLine.AddIntOpt( 'r'  ,r   );		//	r[0|1|2]				ċAI
//			CmdLine.AddIntOpt( 's'  ,s   );		//	s[0|1]				XLbv\̗}
//			CmdLine.AddIntOpt( 't'  ,t   );		//	t[0|1]				ɂ̍XV̎w

//			CmdLine.AddIntOpt( 'u'  ,u   );		//	u[0|1]				t@C̍XViV́j
//			CmdLine.AddIntOpt( 'w'  ,w   );		//	w[0|1|<Dir>]		ƗpfBNg̎w
			if x=0 then CmdLine.Add( '-j' );		//	x[0|1]				fBNgLɂ
//			CmdLine.AddIntOpt( 'y'  ,y   );		//	y[0|1]				SĂ̎ yes Ɖ
//			CmdLine.AddIntOpt( 'z'  ,z   );		//	z[0|1|2|<gq>]	kt@C̎w			###gq̓T|[gȂ###
//			CmdLine.AddIntOpt( 'jc' ,jc  );		//	jc[0|1]				jwb_𖳎
//			CmdLine.AddIntOpt( 'jd' ,jd  );		//	jd[<TCY>]		fBXN̋󂫗eʂmF
//			CmdLine.AddIntOpt( 'je' ,je  );		//	je[<TCY>]		Huffman obt@̑傫w
//			CmdLine.AddIntOpt( 'jf' ,jf  );		//	jf[0|1]				[gL̍폜
//			CmdLine.AddIntOpt( 'jh' ,jh  );		//	jh[0|1]				WindowsNT/95 p̃}[Nɂɕt
//			CmdLine.AddIntOpt( 'ji' ,ji  );		//	ji[0|1]				Zt@CŊi[
//			CmdLine.AddIntOpt( 'jm' ,jm  );		//	jm[0|1|2|3|4]		k`w
//			CmdLine.AddIntOpt( 'jn' ,jn  );		//	jn[0|1]				VKt@Ĉ
//			CmdLine.AddStrOpt( 'jo' ,jo  );		//	jo[<w>]		YYMMDDHHMMSS ̓tȍ~
//			CmdLine.AddStrOpt( 'job',job );		//	job[<w>]	YYMMDDHHMMSS ̓tȑO
//			CmdLine.AddIntOpt( 'jp' ,jp  );		//	jp[0|1]				io[vOXEo[ŕ\
//			CmdLine.AddIntOpt( 'jr' ,jr  );		//	jr[0|1]				t@C̒u
//			CmdLine.AddIntOpt( 'jss',jss );		//	jss[0|1]				kt@CI[vG[𖳎BʏCkɈkΏۃt@
//			CmdLine.AddIntOpt( 'jw' ,jw  );		//	jw[0|1|2|3|4]		WinSFX/WinSFXM 쐬
//			CmdLine.AddLstOpt( 'jx' ,jx  );		//	jx[<t@C>]	Ot@C
//			CmdLine.AddIntOpt( 'jyc',jyc );		//	jyc[0|1]				fBNg쐬̊mFȗ
//			CmdLine.AddIntOpt( 'jyd',jyd );		//	jyd[0|1]				t@C폜̊mFȗ
//			CmdLine.AddIntOpt( 'jyk',jyk );		//	jyk[0|1]				gpłfBXNeʂ̊mF̏ȗ
//			CmdLine.AddIntOpt( 'jyn',jyn );		//	jyn[0|1]				Vt@C̗v̏ȗ
//			CmdLine.AddIntOpt( 'jyo',jyo );		//	jyo[0|1]				t@Cւ̏㏑mF̏ȗ
//			CmdLine.AddStrOpt( 'jz' ,jz  );		//	jz[<t@C>]	t@C߂̃t@C
//			CmdLine.AddIntOpt( 'ga' ,ga  );		//	ga[0|1]				ݕs𖳎
//			CmdLine.AddIntOpt( 'gd' ,gd  );		//	gd[0|1]				]ȃf[^̍폜
//			CmdLine.AddIntOpt( 'ge' ,ge  );		//	ge[0|1]				ŏ̊gqF
//			CmdLine.AddIntOpt( 'gf' ,gf  );		//	gf[0|1|2]			łɂt@C̍XV
//			CmdLine.AddIntOpt( 'gj' ,gj  );		//	gj[0|1]				x ߂ e ߂ƓlƌȂ
//			CmdLine.AddIntOpt( 'gm' ,gm  );		//	gm[0|1]				G[bZ[W\̗}~
//			CmdLine.AddIntOpt( 'gn' ,gn  );		//	gn[0|1|2]			WJt@C̍vTCY 100% ƂiOt̕\
//			CmdLine.AddIntOpt( 'go' ,go  );		//	go[0|1]				_CAÕI[i[EBhE̎w
//			CmdLine.AddIntOpt( 'gp' ,gp  );		//	gp[0|1]				EBhE Disable ɂȂ
//			CmdLine.AddIntOpt( 'gr' ,gr  );		//	gr[<t@C>]	ύXt@C
//			CmdLine.AddIntOpt( 'gs' ,gs  );		//	gs[<TCY>]		wb_TCY̎w
//			CmdLine.AddIntOpt( 'gu' ,gu  );		//	gu[0|1]				WinSFXCDosSFX ɑSẴt@Ci[
//			CmdLine.AddIntOpt( 'gw' ,gw  );		//	gw[0|1|2|3|4]		WinSFX32/WinSFX32M 쐬

			CmdLine.Add( UserOptions );

			AddFileSpec1( CmdLine,ArchiveFileName,Path );
			AddFileSpec2( CmdLine,Options,FileList,UseResFile );

			result := cmd + CmdLine.Str;
		finally
			CmdLine.Free;
		end;
	end;
end;

function TZip32.BuildZipCmd( Cmd,ArchiveFileName:string;Options:TArchiverOptions;Path:String;FileList:array of const;UseResFile:boolean ):String;
var
	CmdLine:	TCmdOpt;
	function zdate( yymmddhhmmss:string ):string;
	var
		yy:	string;
		yyyy:	string;
	begin
		if yymmddhhmmss = aosUnAssigned
		then begin
			result := aosUnAssigned;
			exit;
		end;

		yy := copy( yymmddhhmmss,1,2 );	//	yy
		if StrToInt( yy ) < 80
		then yyyy := '20'+yy
		else yyyy := '19'+yy;

		result := copy( yymmddhhmmss,3,4 )+yyyy;	//	mmdd+yyyy
	end;
//	procedure AddDateOpt( opt,yymmddhhmmss:string );
//	var
//		zd:	string;
//	begin
//		zd := zdate( yymmddhhmmss );
//		if zd <> aosUnAssigned then CmdLine.Add( '-'+opt+' '+zd );
//	end;
begin
{
-	-d	Remove(delete) entries from a zip archive.
		ɓt@C̍폜
-	-f	Freshen(replace) an existing entry in the zip archive
		only if it has been modified more recently than the version
		already in the zip archive.
			ex) zip -f foo
		ɓ̃t@C̍XVs
-	-F	Fix
		ɂ̏C
-	-h	Help
-------------------------------
x	-A	Adjust self-extractiong executable archive.
		ɂȉ𓀎s`ƉB(?)
o	-D	Do not create entries in the zip archive for directories.
		fBNgi[ȂB
x	-e	Encrypt the contents of the zip archive using a password.
		ÍsB(T|[g)
o	-FF	ɂ̏C(ɃTCYMpȂ)
x	-g	Grow(append t) the specified zip archive.
o	-j	Junk the path.
		pXۑȂŃt@Cۑ
o	-J	strip any prepended data(e.g. a SFX stub) from the archive.
		ȉ𓀌`̏ɂ𕁒ʂ̏ɂɂB
o	-k	attempt to convert the names and paths to conform to MSDOS.
		t@CMSDOS`ɕϊB
x	-l	LF->CR LFϊ(Unix->MSDOS)
x	-ll	CR LF->LFϊ(MSDOS->Unix)
x	-m	Move the specified files into the zip archive;
o	-o	set Oldest time
		ɓ̃t@C̍ŏIXVԐVt@C̓ɕύX
		(̓t@Ĉ)
o	-q	Quit mode.
		bZ[W\ȂB
o	-r	travel the directory structure Recursively
			ex) zip -r foo foo
		w肵fBNg/t@CċAIɕۑB
x	-R	travel the directory structure Recursively starting at the
		current directory.
			ex) zip -R foo *.c
		JgfBNgȉ̍\łċAIɌۑB
		(*.cɃ}b`̂̂ݕۑ)
o	-S	include System and hidden files.
		VXe/B̃t@C܂߂B
o	-t mmddyyyy	do not operate on files modified prior to the specified
		data.
			ex) zip -rt 12071997 infamy foo
		wȍ~ɏCꂽt@ĈݑsB
o	-tt mmddyyyy
		wOɏCꂽt@Ĉݑs
o	-u	Updata(replace) an existing entry in the zip archive only if
		it has been modified more recetntly than the version already
		in the zip archive.
		ɓ̃t@CƍŏIXV̔rsV̂̂
		uB
o	-v	Verbose mode or print diagnostic versio info.
		bZ[Wڍו\
x	-X	do not save extra file attributes(Extended Attributes on OS/2
		,uid/gid and file times on Unix)
		Unix,OS/2ŗp(g)͕ۑȂB
x	-$	include the Volume label.
		{[xۑ
o	-#(0-9 number)	Regulate the speed of compression.
		kAXs[h̐ݒB
		(-0:kȂ/-1:ԑ(kŏ)/-9:Ԓx(kő))
		ftHg-6
}
	with Options do begin
		CmdLine := TCmdOpt.Create;
		try
//			CmdLine.Add( '-+' );			//	ɃWXg̐ݒ𖳎
			CmdLine.Filter := Zip32JFilter;

			if a > 0 then CmdLine.Add( '-S' );		//	a[0|1|2]				̍ČB
			if a < 2 then CmdLine.Add( '-D' );		//	a[0|1|2]				̍ČB
//			CmdLine.AddIntOpt( 'c'  ,c   );			//	c[0|1]				^CX^vȗ
//			CmdLine.AddIntOpt( 'd'  ,d   );			//	d[0|1]				fBNg̊i[
//			CmdLine.AddIntOpt( 'e'  ,e   );			//	e[0|1]				TCY𔼕ɂĈk
//			CmdLine.AddIntOpt( 'f'  ,f   );			//	f[0|1]				fBXNcʃ`FbN̒~
//			CmdLine.AddIntOpt( 'h'  ,h   );			//	h[0|1|2|3]			wb_̌`w
//			CmdLine.AddIntOpt( 'i'  ,i   );			//	i[0|1|2]				t@CIő啶Ə
			if l > 0 then CmdLine.Add( '-v' );		//	l[0|1|2]				WJÕt@C̕\@̕ύX

//			CmdLine.AddIntOpt( 'm'  ,m   );			//	m[0|1|2]				 yes Ɖ
			if n > 0 then CmdLine.Add( '-q' );		//	n[0|1]				WJ󋵃_CAO\̗}~
//			CmdLine.AddIntOpt( 'o'  ,o   );			//	o[0|1|2]				`ŏɂ쐬
//			CmdLine.AddIntOpt( 'p'  ,p   );			//	p[0|1|2]				SpXōv
			if r > 0 then CmdLine.Add( '-r' );		//	r[0|1|2]				ċAI
//			CmdLine.AddIntOpt( 's'  ,s   );			//	s[0|1]				XLbv\̗}
			if n > 0 then CmdLine.Add( '-o' );		//	t[0|1]				ɂ̍XV̎w
			if u > 0 then CmdLine.Add( '-u' );		//	u[0|1]				t@C̍XViV́j
//			CmdLine.AddIntOpt( 'w'  ,w   );			//	w[0|1|<Dir>]		ƗpfBNg̎w
			if x = 0 then CmdLine.Add( '-j' );		//	x[0|1]				fBNgLɂ
//			CmdLine.AddIntOpt( 'y'  ,y   );			//	y[0|1]				SĂ̎ yes Ɖ
//			CmdLine.AddIntOpt( 'z'  ,z   );			//	z[0|1|2|<gq>]	kt@C̎w			###gq̓T|[gȂ###
			if jc > 0 then CmdLine.Add( '-FF' );	//	jc[0|1]				jwb_𖳎
//			CmdLine.AddIntOpt( 'jd' ,jd  );			//	jd[<TCY>]		fBXN̋󂫗eʂmF
//			CmdLine.AddIntOpt( 'je' ,je  );			//	je[<TCY>]		Huffman obt@̑傫w
//			CmdLine.AddIntOpt( 'jf' ,jf  );			//	jf[0|1]				[gL̍폜
//			CmdLine.AddIntOpt( 'jh' ,jh  );			//	jh[0|1]				WindowsNT/95 p̃}[Nɂɕt
			if ji > 0 then CmdLine.Add( '-k' );		//	ji[0|1]				Zt@CŊi[
			CmdLine.AddIntOpt( ''   ,jm  );			//	jm[0|1|2|3|4]		k`w
//			CmdLine.AddIntOpt( 'jn' ,jn  );			//	jn[0|1]				VKt@Ĉ

//			CmdLine.AddStrOpt( 't ' ,zdate( jo  ));//	jo [<w>]	YYMMDDHHMMSS ̓tȍ~
//			CmdLine.AddStrOpt( 'tt ',zdate( job ));//	job[<w>]	YYMMDDHHMMSS ̓tȑO

//			AddDateOpt( 't' ,jo  );						//	jo [<w>]	YYMMDDHHMMSS ̓tȍ~
//			AddDateOpt( 'tt',job );						//	job[<w>]	YYMMDDHHMMSS ̓tȑO

//			CmdLine.AddIntOpt( 'jp' ,jp  );			//	jp[0|1]				io[vOXEo[ŕ\
//			CmdLine.AddIntOpt( 'jr' ,jr  );			//	jr[0|1]				t@C̒u
//			CmdLine.AddIntOpt( 'jss',jss );			//	jss[0|1]				kt@CI[vG[𖳎BʏCkɈkΏۃt@
//			CmdLine.AddIntOpt( 'jw' ,jw  );			//	jw[0|1|2|3|4]		WinSFX/WinSFXM 쐬
//			CmdLine.AddLstOpt( 'jx' ,jx  );			//	jx[<t@C>]	Ot@C
//			CmdLine.AddIntOpt( 'jyc',jyc );			//	jyc[0|1]				fBNg쐬̊mFȗ
//			CmdLine.AddIntOpt( 'jyd',jyd );			//	jyd[0|1]				t@C폜̊mFȗ
//			CmdLine.AddIntOpt( 'jyk',jyk );			//	jyk[0|1]				gpłfBXNeʂ̊mF̏ȗ
//			CmdLine.AddIntOpt( 'jyn',jyn );			//	jyn[0|1]				Vt@C̗v̏ȗ
//			CmdLine.AddIntOpt( 'jyo',jyo );			//	jyo[0|1]				t@Cւ̏㏑mF̏ȗ
//			CmdLine.AddStrOpt( 'jz' ,jz  );			//	jz[<t@C>]	t@C߂̃t@C
//			CmdLine.AddIntOpt( 'ga' ,ga  );			//	ga[0|1]				ݕs𖳎
			if gd > 0 then CmdLine.Add( '-J' );		//	gd[0|1]				]ȃf[^̍폜
//			CmdLine.AddIntOpt( 'ge' ,ge  );			//	ge[0|1]				ŏ̊gqF
//			CmdLine.AddIntOpt( 'gf' ,gf  );			//	gf[0|1|2]			łɂt@C̍XV
//			CmdLine.AddIntOpt( 'gj' ,gj  );			//	gj[0|1]				x ߂ e ߂ƓlƌȂ
//			CmdLine.AddIntOpt( 'gm' ,gm  );			//	gm[0|1]				G[bZ[W\̗}~
//			CmdLine.AddIntOpt( 'gn' ,gn  );			//	gn[0|1|2]			WJt@C̍vTCY 100% ƂiOt̕\
//			CmdLine.AddIntOpt( 'go' ,go  );			//	go[0|1]				_CAÕI[i[EBhE̎w
//			CmdLine.AddIntOpt( 'gp' ,gp  );			//	gp[0|1]				EBhE Disable ɂȂ
//			CmdLine.AddIntOpt( 'gr' ,gr  );			//	gr[<t@C>]	ύXt@C
//			CmdLine.AddIntOpt( 'gs' ,gs  );			//	gs[<TCY>]		wb_TCY̎w
//			CmdLine.AddIntOpt( 'gu' ,gu  );			//	gu[0|1]				WinSFXCDosSFX ɑSẴt@Ci[
//			CmdLine.AddIntOpt( 'gw' ,gw  );			//	gw[0|1|2|3|4]		WinSFX32/WinSFX32M 쐬

			CmdLine.Add( UserOptions );

			AddFileSpec1( CmdLine,ArchiveFileName,Path );
			AddFileSpec2( CmdLine,Options,FileList,UseResFile );

			result := cmd + CmdLine.Str;
		finally
			CmdLine.Free;
		end;
	end;
end;

function TZip32.FindOpen( Handle:HWND;ArchiveFileName:string;dwMode:DWORD ):THARC;
begin
	result:= FArchiver.OpenArchive( Handle,PChar( ExpandFileName( ArchiveFileName )),dwMode );
end;

function TZip32.FindClose( hArc:THArc ):integer;
begin
	result := FArchiver.CloseArchive( hArc );
end;

function TZip32.FindFirst( hArc:THArc;var IndivisualInfo:TIndivisualInfo;FileMask:string ):integer;
begin
	result := FArchiver.FindFirst( hArc,PChar( FileMask ),@IndivisualInfo );
end;

function TZip32.FindNext( hArc:THArc;var IndivisualInfo:TIndivisualInfo ):integer;
begin
	result := FArchiver.FindNext( hArc,@IndivisualInfo )
end;

function IsZipArchive1( ArchiveFileName:string ):boolean;
var
	SfxType:	integer;
begin
	try
		LoadDll;
		SfxType:= FArchiver.CheckArchive( PChar( ExpandFileName( ArchiveFileName )),CHECKARCHIVE_SFX+CHECKARCHIVE_ALL );
		result := ( SfxType <> 0 );
	except
		result := false;
	end;
end;

function IsZipArchive2( ArchiveFileName:string ):boolean;
var
	hArc:		THARC;
begin
	try
		LoadDLL;
		ArchiveFileName := ExpandFileName( ArchiveFileName );
		result := false;
		if not FileExists( ArchiveFileName ) then exit;
		hArc := FArchiver.OpenArchive( 0,PAnsiChar( ArchiveFileName ),M_REGARDLESS_INIT_FILE+M_ERROR_MESSAGE_OFF );
		if hArc <> 0 then FArchiver.CloseArchive( hArc );
		result := ( hArc <> 0 );
	except
		result := false;
	end;
end;

function IsZipArchive( ArchiveFileName:string ):boolean;
begin
	result := IsZipArchive1( ArchiveFileName ) and IsZipArchive2( ArchiveFileName );
end;

end.
